/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports,require("@tensorflow/tfjs-core"),require("path"),require("fs"),require("worker_threads"),require("perf_hooks")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","path","fs","worker_threads","perf_hooks"],n):n(((e=e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.path,e.fs,e.worker_threads,e.perf_hooks)}(this,(function(e,n,t,r,a,u){"use strict";var i,s,o;t=t&&t.hasOwnProperty("default")?t.default:t,r=r&&r.hasOwnProperty("default")?r.default:r,a=a&&a.hasOwnProperty("default")?a.default:a,u=u&&u.hasOwnProperty("default")?u.default:u,function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(i||(i={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu",e[e.leakyrelu=4]="leakyrelu"}(s||(s={}));var l={kernelName:n._FusedMatMul,backendName:"wasm",setupFunc:function(e){o=e.wasm.cwrap(n._FusedMatMul,null,["number","array","number","number","array","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,t=e.backend,r=e.attrs,a=n.a,u=n.b,i=n.bias,l=n.preluActivationWeights;if("float32"!==a.dtype||"float32"!==u.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");var d=r.transposeA,c=r.transposeB,p=r.activation,f=r.leakyreluAlpha,m=t.dataIdMap.get(a.dataId).id,h=t.dataIdMap.get(u.dataId).id,b=0;if(null!=i){var _=t.dataIdMap.get(i.dataId);if(1!==_.shape.length)throw new Error("_FusedMatMul only supports rank-1 bias but got rank "+_.shape.length+".");b=_.id}var y=null==l?0:t.dataIdMap.get(l.dataId).id,v=s[p];if(null==v)throw new Error(p+" activation not yet supported for FusedConv2D in the wasm backend.");var g=d?a.shape[2]:a.shape[1],w=c?u.shape[1]:u.shape[2],k=a.shape[0],I=t.makeOutput([k,g,w],a.dtype),S=t.dataIdMap.get(I.dataId).id,E=new Uint8Array(new Int32Array(a.shape).buffer),A=new Uint8Array(new Int32Array(u.shape).buffer);return o(m,E,a.shape.length,h,A,u.shape.length,d,c,v,b,y,f||0,S),I}};function d(e){var t;return{kernelName:e,backendName:"wasm",setupFunc:function(n){t=n.wasm.cwrap(e,null,["number","number"])},kernelFunc:function(e){var r=e.backend,a=e.inputs.x,u=r.dataIdMap.get(a.dataId).id,i=r.makeOutput(a.shape,a.dtype),s=r.dataIdMap.get(i.dataId).id;return 0===n.util.sizeFromShape(i.shape)||t(u,s),i}}}var c=d(n.Abs);function p(e,t,r){var a;return{kernelName:e,backendName:"wasm",setupFunc:function(n){a=n.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(u){var s=u.backend,o=u.inputs,l=o.a,d=o.b,c=s.dataIdMap.get(l.dataId).id,p=s.dataIdMap.get(d.dataId).id,f=null!=r?r:l.dtype,m=n.backend_util.assertAndGetBroadcastShape(l.shape,d.shape),h=s.makeOutput(m,f);if(0===n.util.sizeFromShape(m))return h;var b=new Uint8Array(new Int32Array(l.shape).buffer),_=new Uint8Array(new Int32Array(d.shape).buffer),y=s.dataIdMap.get(h.dataId).id,v=function(){return a(c,b,l.shape.length,p,_,d.shape.length,i[l.dtype],y)};if(t&&"float32"===l.dtype)return v(),h;var g=n.backend_util.getBroadcastDims(l.shape,m),w=n.backend_util.getBroadcastDims(d.shape,m),k=g.every((function(e,n){return e===n})),I=w.every((function(e,n){return e===n}));if(k&&I)return v(),h;throw new Error("Broadcasting along outer dims is not yet supported for "+l.dtype+" "+e+".")}}}var f,m=p(n.Add,!0);var h={kernelName:n.AddN,backendName:"wasm",setupFunc:function(e){f=e.wasm.cwrap(n.AddN,null,["array","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.backend,a=r.makeOutput(t[0].shape,t[0].dtype);if(0===n.util.sizeFromShape(a.shape))return a;var u=t.map((function(e){return r.dataIdMap.get(e.dataId).id})),s=new Uint8Array(new Int32Array(u).buffer),o=r.dataIdMap.get(a.dataId).id;return f(s,u.length,i[a.dtype],o),a}};function b(e){var n=e.inputs.x,t=e.backend,r=t.makeOutput(n.shape,n.dtype),a=t.typedArrayFromHeap(n);return t.typedArrayFromHeap(r).set(a),r}var _,y={kernelName:n.Identity,backendName:"wasm",kernelFunc:b};function v(e){for(var n=e.inputs,t=e.backend,r=e.attrs,a=function(e,n){for(var t=[],r=[],a=0;a<e.length;++a)1!==e[a]&&t.push(e[a]),1!==e[n[a]]&&r.push(n[a]);for(a=0;a<r.length;++a){for(var u=-1,i=0;i<r.length;++i)r[i]>=a&&(-1===u||r[u]>r[i])&&(u=i);r[u]=a}return[t,r]}(n.x.shape,r.perm),u=a[0],s=a[1],o=!0,l=0;l<s.length;l++)s[l]!==l&&(o=!1);var d=function(e,n){for(var t=new Array(e.length),r=0;r<t.length;r++)t[r]=e[n[r]];return t}(n.x.shape,r.perm),c={dataId:n.x.dataId,shape:u,dtype:n.x.dtype};if(o){var p=b({inputs:n,backend:t});return p.shape=d,p}var f=t.makeOutput(d,c.dtype),m=t.dataIdMap.get(c.dataId).id,h=t.dataIdMap.get(f.dataId).id,y=new Uint8Array(new Int32Array(s).buffer),v=new Uint8Array(new Int32Array(c.shape).buffer);return _(m,v,c.shape.length,i[c.dtype],h,y,s.length),f}var g,w={kernelName:n.Transpose,backendName:"wasm",kernelFunc:v,setupFunc:function(e){_=e.wasm.cwrap(n.Transpose,null,["number","array","number","number","number","array","number"])}};function k(e,t,r){var a=e.shape,u=e.shape.length,i=n.util.parseAxisParam(t,a),s=i,o=n.backend_util.getAxesPermutation(s,u),l=null,d=!1;if(null!=o){for(var c=new Array(u),p=0;p<c.length;p++)c[p]=a[o[p]];s=n.backend_util.getInnerMostAxes(s.length,u),l=v({inputs:{x:e},attrs:{perm:o},backend:r});var f=r.dataIdMap.get(e.dataId).id;r.dataIdMap.get(l.dataId).id!==f&&(d=!0)}return{transposed:l,originalAxes:i,axes:s,inputWasTransposed:d}}var I,S={kernelName:n.ArgMax,backendName:"wasm",kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs.axis,u=r.x,s=t.dataIdMap.get(u.dataId).id,o=s,l=u,d=k(u,a,t),c=d.transposed,p=d.axes,f=d.inputWasTransposed;if(f){var m=t.dataIdMap.get(c.dataId).id;m!==s&&(l=c,o=m)}var h=l.shape.slice(0,-1),b=t.makeOutput(h,"int32"),_=t.dataIdMap.get(b.dataId).id,y=n.util.sizeFromShape(b.shape),v=l.shape[p[0]];return g(o,i[l.dtype],y,v,_),f&&t.disposeData(c.dataId),b},setupFunc:function(e){g=e.wasm.cwrap(n.ArgMax,null,["number","number","number","number","number"])}};var E={kernelName:n.AvgPool,backendName:"wasm",setupFunc:function(e){I=e.wasm.cwrap(n.AvgPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.x,i=a.dataIdMap.get(u.dataId).id,s=r.filterSize,o=r.strides,l=r.pad,d=r.dimRoundingMode,c=n.backend_util.computePool2DInfo(u.shape,s,o,1,l,d),p=c.filterHeight,f=c.filterWidth,m=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,_=c.padInfo.left,y=c.strideHeight,v=c.strideWidth,g=c.inChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");if(1!==c.dilationWidth||1!==c.dilationHeight)throw new Error("was backend only supports average pooling with dilation = [1, 1], got ["+c.dilationHeight+", "+c.dilationWidth+"].");var w=a.makeOutput(c.outShape,"float32"),k=a.dataIdMap.get(w.dataId).id;return I(i,u.shape[0],u.shape[1],u.shape[2],p,f,m,h,b,_,y,v,g,k),w}};function A(e){var t=e.inputs,r=e.attrs,a=t.x,u=r.shape,i=n.util.sizeFromShape(a.shape),s=n.util.inferFromImplicitShape(u,i);return n.util.assert(i===n.util.sizeFromShape(s),(function(){return"new shape: "+s+", old shape: "+a.shape+". New shape and old shape must have the same number of elements."})),{dataId:a.dataId,shape:s,dtype:a.dtype}}var M,x={kernelName:n.Reshape,backendName:"wasm",kernelFunc:A};var N={kernelName:n.BatchMatMul,backendName:"wasm",setupFunc:function(e){M=e.wasm.cwrap(n.BatchMatMul,null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.backend,a=e.attrs,u=t.a,i=t.b,s=a.transposeA,o=a.transposeB;if("float32"!==u.dtype||"float32"!==i.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");var l=u.shape.length,d=i.shape.length,c=s?u.shape[l-2]:u.shape[l-1],p=o?i.shape[d-1]:i.shape[d-2],f=s?u.shape[l-1]:u.shape[l-2],m=o?i.shape[d-2]:i.shape[d-1],h=u.shape.slice(0,-2),b=i.shape.slice(0,-2),_=n.util.sizeFromShape(h),y=n.util.sizeFromShape(b),v=_===y||1===_||1===y;n.util.assert(l>=2&&d>=2&&v,(function(){return"Error in matMul: the input batch dimensions must either be the same or at least one input batch dimension must be 1. Got input batch dimensions of ("+h+") and ("+b+")."}));var g=(_>y?u.shape.slice(0,-2):i.shape.slice(0,-2)).concat([f,m]);n.util.assert(c===p,(function(){return"Error in matMul: inner shapes ("+c+") and ("+p+") of Tensors with shapes "+u.shape+" and "+i.shape+" and transposeA="+s+" and transposeB="+o+" must match."}));var w=o?[y,m,p]:[y,p,m],k=A({inputs:{x:u},backend:r,attrs:{shape:s?[_,c,f]:[_,f,c]}}),I=A({inputs:{x:i},backend:r,attrs:{shape:w}}),S=r.dataIdMap.get(k.dataId).id,E=r.dataIdMap.get(I.dataId).id,x=s?k.shape[2]:k.shape[1],N=o?I.shape[1]:I.shape[2],F=Math.max(_,y),T=r.makeOutput([F,x,N],k.dtype),O=r.dataIdMap.get(T.dataId).id,C=new Uint8Array(new Int32Array(k.shape).buffer),R=new Uint8Array(new Int32Array(I.shape).buffer);return M(S,C,k.shape.length,E,R,I.shape.length,s,o,O),T.shape=g,T}};function F(e){var n=e.inputs.x,t=e.attrs.dtype,r=e.backend,a=r.makeOutput(n.shape,t),u=r.typedArrayFromHeap(n);return r.typedArrayFromHeap(a).set(u),a}var T,O={kernelName:n.Cast,backendName:"wasm",kernelFunc:F};var C={kernelName:n.ClipByValue,backendName:"wasm",setupFunc:function(e){T=e.wasm.cwrap(n.ClipByValue,null,["number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,t=e.backend,r=e.attrs,a=n.x,u=r.clipValueMin,i=r.clipValueMax,s=t.dataIdMap.get(a.dataId).id,o=t.makeOutput(a.shape,a.dtype),l=t.dataIdMap.get(o.dataId).id;return T(s,u,i,l),o}};function R(e,t,r,a,u){const i=n.slice_util.isSliceContinous(a,t,r),s=n.util.sizeFromShape(r),o=n.util.computeStrides(a);if(i){const r=n.slice_util.computeFlatOffset(t,o);return"string"===u?e.slice(r,r+s):e.subarray(r,r+s)}const l="string"===u?n.backend_util.fromUint8ToStringArray(e):e,d=n.buffer(a,u,l),c=n.buffer(r,u);for(let e=0;e<c.size;++e){const n=c.indexToLoc(e),r=n.map((e,n)=>e+t[n]);c.set(d.get(...r),...n)}return"string"===u?n.backend_util.fromStringArrayToUint8(c.values):c.values}function D(e){var t=e.inputs,r=e.backend,a=n.util.parseAxisParam(e.attrs.axis,t[0].shape)[0],u=n.backend_util.computeOutShape(t.map((function(e){return e.shape})),a),i=t.filter((function(e){return n.util.sizeFromShape(e.shape)>0}));if(1===i.length)return b({inputs:{x:i[0]},backend:r});var s=r.makeOutput(u,t[0].dtype);if(0===n.util.sizeFromShape(u))return s;var o=i.map((function(e){return e.shape}));if(n.backend_util.assertParamsConsistent(o,a),"string"===i[0].dtype){var l=i.map((function(e){var t=n.util.sizeFromShape(e.shape.slice(a));return A({inputs:{x:e},backend:r,attrs:{shape:[-1,t]}})})),d=l.map((function(e){return{vals:r.readSync(e.dataId),shape:e.shape}}));u=n.backend_util.computeOutShape(l.map((function(e){return e.shape})),1);var c=1===l[0].shape[0],p=function(e,t,r,a){const u=n.util.getArrayFromDType(r,n.util.sizeFromShape(t));if(a&&"string"!==r){let t=0;e.forEach(e=>{const r=n.util.sizeFromShape(e.shape);u.set(e.vals,t),t+=r})}else{let a=0;e.forEach(e=>{const i="string"===r?n.backend_util.fromUint8ToStringArray(e.vals):e.vals;let s=0;for(let n=0;n<e.shape[0];++n){const r=n*t[1]+a;for(let n=0;n<e.shape[1];++n)u[r+n]=i[s++]}a+=e.shape[1]})}return u}(d,u,t[0].dtype,c),f=n.backend_util.computeOutShape(i.map((function(e){return e.shape})),a);return s.shape=f,r.dataIdMap.get(s.dataId).stringBytes=n.backend_util.fromStringArrayToUint8(p),s}for(var m=n.util.sizeFromShape(i[0].shape.slice(0,a)),h=0,_=i.map((function(e){var t=n.util.sizeFromShape(e.shape.slice(a));return h+=t,t})),y=i.map((function(e){return r.typedArrayFromHeap(e)})),v=r.typedArrayFromHeap(s),g=0;g<m;g++)for(var w=g*h,k=0;k<y.length;k++){var I=_[k],S=g*I,E=y[k].subarray(S,S+I);v.set(E,w),w+=I}return s}var P,W={kernelName:n.Concat,backendName:"wasm",kernelFunc:D};var B,L={kernelName:n.Conv2D,backendName:"wasm",setupFunc:function(e){P=e.wasm.cwrap(n.Conv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.x,i=t.filter,s=a.dataIdMap.get(u.dataId).id,o=a.dataIdMap.get(i.dataId).id,l=r.strides,d=r.dilations,c=r.pad,p=r.dimRoundingMode,f=r.dataFormat,m=n.backend_util.convertConv2DDataFormat(f),h=n.backend_util.computeConv2DInfo(u.shape,i.shape,l,d,c,p,!1,m),b=h.filterHeight,_=h.filterWidth,y=h.padInfo.top,v=h.padInfo.right,g=h.padInfo.bottom,w=h.padInfo.left,k=h.dilationHeight,I=h.dilationWidth,S=h.strideHeight,E=h.strideWidth,A=h.inChannels,M=h.outChannels,x="SAME"===h.padInfo.type?1:0;if("channelsLast"!==h.dataFormat)throw new Error("wasm backend Conv2D does not support dataFormat:'"+h.dataFormat+"'. Please use 'channelsLast'.");var N=a.makeOutput(h.outShape,"float32"),F=a.dataIdMap.get(N.dataId).id;return P(s,u.shape[0],u.shape[1],u.shape[2],o,b,_,y,v,g,w,x,k,I,S,E,A,M,F),N}};var H,U,z={kernelName:n.Conv2DBackpropInput,backendName:"wasm",setupFunc:function(e){B=e.wasm.cwrap(n.Conv2DBackpropInput,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=r.dy,i=r.filter,s=a.strides,o=a.pad,l=a.dataFormat,d=a.dimRoundingMode,c=a.inputShape,p=n.backend_util.convertConv2DDataFormat(l),f=n.backend_util.computeConv2DInfo(c,i.shape,s,1,o,d,!1,p),m=f.batchSize,h=f.filterHeight,b=f.filterWidth,_=f.inChannels,y=f.inHeight,v=f.inWidth,g=f.outChannels,w=f.outHeight,k=f.outWidth,I=f.strideHeight,S=f.strideWidth,E=h-1-f.padInfo.top,A=b-1-f.padInfo.left,M="channelsLast"===f.dataFormat,x=n.util.computeStrides(f.inShape),N=n.util.computeStrides(u.shape),F=n.util.computeStrides(i.shape),T=F[0],O=F[1],C=F[2],R=x[0],D=M?x[1]:x[2],P=M?x[2]:1,W=M?1:x[1],L=N[0],H=M?N[1]:N[2],U=M?N[2]:1,z=M?1:N[1],j=t.makeOutput(f.inShape,"float32"),q=t.dataIdMap.get(j.dataId).id,V=t.dataIdMap.get(u.dataId).id,G=t.dataIdMap.get(i.dataId).id;return B(V,G,m,h,b,y,v,_,w,k,g,I,S,E,A,T,O,C,R,D,P,W,L,H,U,z,q),j}},j=d(n.Cos);!function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(H||(H={}));var q,V={kernelName:n.CropAndResize,backendName:"wasm",setupFunc:function(e){U=e.wasm.cwrap(n.CropAndResize,null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){var n,t=e.backend,r=e.inputs,a=e.attrs,u=a.method,i=a.extrapolationValue,s=a.cropSize,o=r.image,l=r.boxes,d=r.boxInd,c=l.shape[0],p=s,f=p[0],m=p[1],h=[c,f,m,o.shape[3]],b=t.dataIdMap.get(o.dataId);"float32"!==o.dtype&&(n=F({backend:t,inputs:{x:o},attrs:{dtype:"float32"}}),b=t.dataIdMap.get(n.dataId));var _=b.id,y=t.dataIdMap.get(l.dataId).id,v=t.dataIdMap.get(d.dataId).id,g=t.makeOutput(h,"float32"),w=t.dataIdMap.get(g.dataId).id,k=new Uint8Array(new Int32Array(o.shape).buffer);return U(_,y,v,c,k,f,m,H[u],i,w),null!=n&&t.disposeData(n.dataId),g}};var G,K={kernelName:n.Cumsum,backendName:"wasm",setupFunc:function(e){q=e.wasm.cwrap(n.Cumsum,null,["number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.backend,a=e.attrs,u=t.x,s=a.axis,o=a.exclusive,l=a.reverse,d=u.shape.length;n.util.assert("float32"===u.dtype||"int32"===u.dtype,(function(){return"cumsum does not support "+u.dtype+" tensors in the WASM backend"}));var c=n.backend_util.getAxesPermutation([s],d),p=u;null!==c&&(p=v({inputs:{x:u},attrs:{perm:c},backend:r}));var f=n.backend_util.getInnerMostAxes(1,d)[0];n.backend_util.assertAxesAreInnerMostDims("cumsum",[f],d);var m=r.makeOutput(p.shape,p.dtype),h=p.shape[f],b=r.dataIdMap.get(p.dataId).id,_=r.dataIdMap.get(m.dataId).id;q(b,o?1:0,l?1:0,h,_,i[u.dtype]);var y=m;return null!==c&&(y=v({inputs:{x:m},attrs:{perm:n.backend_util.getUndoAxesPermutation(c)},backend:r}),r.disposeData(p.dataId),r.disposeData(m.dataId)),y}};var X,Y={kernelName:n.DepthToSpace,backendName:"wasm",setupFunc:function(e){G=e.wasm.cwrap(n.DepthToSpace,null,["number","number","number","array","number","array","array","number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=r.x,i=a.blockSize,s=a.dataFormat;n.util.assert(i>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+i}));var o=u.shape[0],l="NHWC"===s?u.shape[1]:u.shape[2],d="NHWC"===s?u.shape[2]:u.shape[3],c="NHWC"===s?u.shape[3]:u.shape[1],p=l*i,f=d*i,m=c/(i*i),h="NHWC"===s?[o,p,f,m]:[o,m,p,f],b=t.makeOutput(h,"float32"),_=t.dataIdMap.get(u.dataId).id,y=new Uint8Array(new Int32Array(n.util.computeStrides(u.shape)).buffer),v=new Uint8Array(new Int32Array(h).buffer),g=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer),w=t.dataIdMap.get(b.dataId).id;return G(_,i,"NHWC"===s?1:0,y,u.shape.length-1,v,g,h.length,w),b}};var Q={kernelName:n.DepthwiseConv2dNative,backendName:"wasm",setupFunc:function(e){X=e.wasm.cwrap(n.DepthwiseConv2dNative,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.x,i=t.filter,s=a.dataIdMap.get(u.dataId).id,o=a.dataIdMap.get(i.dataId).id,l=r.strides,d=r.dilations,c=r.pad,p=r.dimRoundingMode,f=null==d?[1,1]:d,m=n.backend_util.computeConv2DInfo(u.shape,i.shape,l,f,c,p,!0),h=m.filterHeight,b=m.filterWidth,_=m.padInfo.top,y=m.padInfo.right,v=m.padInfo.bottom,g=m.padInfo.left,w=m.dilationHeight,k=m.dilationWidth,I=m.strideHeight,S=m.strideWidth,E=m.inChannels,A=m.outChannels,M="SAME"===m.padInfo.type?1:0;if("channelsLast"!==m.dataFormat)throw new Error("wasm backend DepthwiseConv2dNative does not support dataFormat:'"+m.dataFormat+"'. Please use 'channelsLast'.");var x=a.makeOutput(m.outShape,"float32"),N=a.dataIdMap.get(x.dataId).id;return X(s,u.shape[0],u.shape[1],u.shape[2],o,h,b,_,y,v,g,M,w,k,I,S,E,A,N),x}},Z=p(n.Equal,!1,"bool"),J=d(n.Exp);function $(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.input,i=r.dim,s=u.shape.length,o=u.shape.slice(),l=i;return i<0&&(n.util.assert(-(s+1)<=i,(function(){return"Axis must be in the interval ["+-(s+1)+", "+s+"]"})),l=s+i+1),o.splice(l,0,1),A({inputs:{x:u},backend:a,attrs:{shape:o}})}var ee={kernelName:n.ExpandDims,backendName:"wasm",kernelFunc:$};var ne,te={kernelName:n.Fill,backendName:"wasm",kernelFunc:function(e){var n=e.attrs,t=n.shape,r=n.value,a=n.dtype,u=e.backend,i=u.makeOutput(t,a);return u.typedArrayFromHeap(i).fill(r),i}};var re,ae={kernelName:n.FlipLeftRight,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,t=e.backend,r=n.image,a=t.makeOutput(r.shape,r.dtype),u=t.dataIdMap.get(r.dataId).id,i=t.dataIdMap.get(a.dataId).id,s=r.shape,o=s[0],l=s[1],d=s[2],c=s[3];return ne(u,o,l,d,c,i),a},setupFunc:function(e){ne=e.wasm.cwrap(n.FlipLeftRight,null,["number","number","number","number","number","number"])}},ue=d(n.Floor),ie=p(n.FloorDiv,!1);var se,oe={kernelName:n.FusedBatchNorm,backendName:"wasm",setupFunc:function(e){re=e.wasm.cwrap(n.FusedBatchNorm,null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs.varianceEpsilon,u=r.x,i=r.mean,s=r.variance,o=r.offset,l=r.scale,d=t.dataIdMap.get(u.dataId).id,c=t.dataIdMap.get(i.dataId).id,p=t.dataIdMap.get(s.dataId).id,f=null!=o?t.dataIdMap.get(o.dataId).id:0,m=null!=l?t.dataIdMap.get(l.dataId).id:0,h=t.makeOutput(u.shape,u.dtype);if(0===n.util.sizeFromShape(u.shape))return h;var b=t.dataIdMap.get(h.dataId).id;return re(d,c,p,f,m,a,b),h}};var le,de={kernelName:n.FusedConv2D,backendName:"wasm",setupFunc:function(e){se=e.wasm.cwrap(n.FusedConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.x,i=t.filter,o=t.bias,l=t.preluActivationWeights,d=r.strides,c=r.pad,p=r.dilations,f=r.dataFormat,m=r.dimRoundingMode,h=r.activation,b=r.leakyreluAlpha,_=n.backend_util.computeConv2DInfo(u.shape,i.shape,d,p,c,m),y=s[h];if(null==y)throw new Error(h+" activation not yet supported for FusedConv2D in the wasm backend.");var v=a.dataIdMap.get(u.dataId).id,g=a.dataIdMap.get(i.dataId).id,w=_.outChannels,k=0;if(null!=o){var I=a.dataIdMap.get(o.dataId);if(1!==I.shape.length)throw new Error("FusedConv2D only supports rank-1 bias but got rank "+I.shape.length+".");if(I.shape[0]!==w)throw new Error("FusedConv2D bias shape ("+I.shape+") does not match the number of output channels ("+w+")");k=I.id}var S=_.filterHeight,E=_.filterWidth,A=_.padInfo.top,M=_.padInfo.right,x=_.padInfo.bottom,N=_.padInfo.left,F=_.dilationHeight,T=_.dilationWidth,O=_.strideHeight,C=_.strideWidth,R=_.inChannels,D="SAME"===_.padInfo.type?1:0,P=_.batchSize,W=_.inHeight,B=_.inWidth;if("NHWC"!==f)throw new Error("wasm backend FusedConv2D does not support dataFormat:'"+f+"'. Please use 'NHWC'.");var L=a.makeOutput(_.outShape,"float32"),H=a.dataIdMap.get(L.dataId).id,U=null==l?0:a.dataIdMap.get(l.dataId).id;return se(v,P,W,B,g,S,E,k,A,M,x,N,D,F,T,O,C,R,w,y,U,b||0,H),L}};var ce,pe={kernelName:n.FusedDepthwiseConv2D,backendName:"wasm",setupFunc:function(e){le=e.wasm.cwrap(n.FusedDepthwiseConv2D,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.x,i=t.filter,o=t.bias,l=t.preluActivationWeights,d=r.strides,c=r.pad,p=r.dilations,f=r.dataFormat,m=r.dimRoundingMode,h=r.activation,b=r.leakyreluAlpha,_=n.backend_util.computeConv2DInfo(u.shape,i.shape,d,p,c,m,!0),y=s[h];if(null==y)throw new Error(h+" activation not yet supported for FusedDepthwiseConv2D in the wasm backend.");var v=a.dataIdMap.get(u.dataId).id,g=a.dataIdMap.get(i.dataId).id,w=_.outChannels,k=0;if(null!=o){var I=a.dataIdMap.get(o.dataId);if(1!==I.shape.length)throw new Error("FusedDepthwiseConv2D only supports rank-1 bias but got rank "+I.shape.length+".");if(I.shape[0]!==w)throw new Error("FusedDepthwiseConv2D bias shape ("+I.shape+") does not match the number of output channels ("+w+")");k=I.id}var S=_.filterHeight,E=_.filterWidth,A=_.padInfo.top,M=_.padInfo.right,x=_.padInfo.bottom,N=_.padInfo.left,F=_.dilationHeight,T=_.dilationWidth,O=_.strideHeight,C=_.strideWidth,R=_.inChannels,D="SAME"===_.padInfo.type?1:0,P=_.batchSize,W=_.inHeight,B=_.inWidth;if("NHWC"!==f)throw new Error("wasm backend FusedDepthwiseConv2D does not support dataFormat:'"+f+"'. Please use 'NHWC'.");var L=a.makeOutput(_.outShape,"float32"),H=a.dataIdMap.get(L.dataId).id,U=null==l?0:a.dataIdMap.get(l.dataId).id;return le(v,P,W,B,g,S,E,k,A,M,x,N,D,F,T,O,C,R,w,y,U,b||0,H),L}};var fe,me={kernelName:n.GatherNd,backendName:"wasm",setupFunc:function(e){ce=e.wasm.cwrap(n.GatherNd,null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=r.params,u=r.indices,s=n.gather_util.prepareAndValidate(a,u),o=s[0],l=s[1],d=s[2],c=s[3],p=t.makeOutput(o,a.dtype);if(0===l)return p;var f=u.shape,m=f[f.length-1],h=t.dataIdMap.get(a.dataId).id,b=t.dataIdMap.get(u.dataId).id,_=new Uint8Array(new Int32Array(c).buffer),y=t.dataIdMap.get(p.dataId).id;return ce(h,i[a.dtype],b,l,m,d,_,y),p}};var he,be={kernelName:n.GatherV2,backendName:"wasm",setupFunc:function(e){fe=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=r.x,s=r.indices,o=a.axis,l=a.batchDims,d=n.util.parseAxisParam(o,u.shape)[0],c=n.backend_util.segment_util.collectGatherOpShapeInfo(u,s,d,l),p=A({inputs:{x:u},attrs:{shape:[c.batchSize,c.outerSize,c.dimSize,c.sliceSize]},backend:t}),f=n.util.sizeFromShape(s.shape),m=A({inputs:{x:s},attrs:{shape:[c.batchSize,f/c.batchSize]},backend:t}),h=[c.batchSize,c.outerSize,f/c.batchSize,c.sliceSize],b=t.makeOutput(h,u.dtype);if(0===n.util.sizeFromShape(u.shape))return b;var _=p.shape.length-1,y=t.dataIdMap.get(p.dataId).id,v=t.dataIdMap.get(m.dataId).id,g=t.dataIdMap.get(b.dataId).id,w=new Uint8Array(new Int32Array(n.util.computeStrides(p.shape)).buffer),k=new Uint8Array(new Int32Array(n.util.computeStrides(h)).buffer);return fe(y,i[u.dtype],w,_,v,c.batchSize,k,g),b.shape=c.outputShape,b}},_e=p(n.Greater,!1,"bool"),ye=p(n.GreaterEqual,!1,"bool");var ve,ge={kernelName:n.LeakyRelu,backendName:"wasm",setupFunc:function(e){he=e.wasm.cwrap(n.LeakyRelu,null,["number","number","number"])},kernelFunc:function(e){var t=e.inputs.x,r=e.attrs.alpha,a=e.backend,u=a.dataIdMap.get(t.dataId).id,i=a.makeOutput(t.shape,t.dtype);if(0!==n.util.sizeFromShape(t.shape)){var s=a.dataIdMap.get(i.dataId).id;he(u,r,s)}return i}},we=p(n.Less,!1,"bool"),ke=p(n.LessEqual,!1,"bool"),Ie=d(n.Log),Se=p(n.LogicalAnd,!1,"bool");var Ee,Ae={kernelName:n.Max,backendName:"wasm",setupFunc:function(e){ve=e.wasm.cwrap(n.Max,null,["number, number, number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=a.reductionIndices,i=a.keepDims,s=r.x,o=t.dataIdMap.get(s.dataId).id,l=s,d=k(s,u,t),c=d.transposed,p=d.axes,f=d.originalAxes,m=d.inputWasTransposed;m&&(l=c,o=t.dataIdMap.get(c.dataId).id);var h=l.shape.length;n.backend_util.assertAxesAreInnerMostDims("max",p,h);var b=n.backend_util.computeOutAndReduceShapes(l.shape,p),_=b[0],y=b[1],v=n.util.sizeFromShape(y),g=t.makeOutput(_,s.dtype);if(0!==n.util.sizeFromShape(l.shape)){var w=t.dataIdMap.get(g.dataId).id;ve(o,v,w)}if(m&&t.disposeData(c.dataId),i){var I=n.backend_util.expandShapeToKeepDim(g.shape,f);g.shape=I}return g}},Me=p(n.Maximum,!1);var xe,Ne={kernelName:n.MaxPool,backendName:"wasm",setupFunc:function(e){Ee=e.wasm.cwrap(n.MaxPool,null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.x,i=a.dataIdMap.get(u.dataId).id,s=r.filterSize,o=r.strides,l=r.pad,d=r.dimRoundingMode,c=n.backend_util.computePool2DInfo(u.shape,s,o,1,l,d),p=c.filterHeight,f=c.filterWidth,m=c.padInfo.top,h=c.padInfo.right,b=c.padInfo.bottom,_=c.padInfo.left,y=c.dilationHeight,v=c.dilationWidth,g=c.strideHeight,w=c.strideWidth,k=c.inChannels,I=c.outChannels;if("channelsLast"!==c.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+c.dataFormat+"'. Please use 'channelsLast'.");var S=a.makeOutput(c.outShape,"float32"),E=a.dataIdMap.get(S.dataId).id;return Ee(i,u.shape[0],u.shape[1],u.shape[2],p,f,m,h,b,_,y,v,g,w,k,I,E),S}};var Fe,Te={kernelName:n.Mean,backendName:"wasm",setupFunc:function(e){xe=e.wasm.cwrap(n.Mean,null,["number, number, number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=a.axis,i=a.keepDims,s=r.x,o=t.dataIdMap.get(s.dataId).id,l=o,d=s,c=k(s,u,t),p=c.transposed,f=c.axes,m=c.originalAxes,h=c.inputWasTransposed,b=f;if(h){var _=t.dataIdMap.get(p.dataId).id;_!==o&&(d=p,l=_,b=n.backend_util.getInnerMostAxes(b.length,d.shape.length))}n.backend_util.assertAxesAreInnerMostDims("mean",b,d.shape.length);var y=n.backend_util.computeOutAndReduceShapes(d.shape,b),v=y[0],g=y[1],w=n.util.sizeFromShape(g),I=d;"float32"!==d.dtype&&(I=F({backend:t,inputs:{x:d},attrs:{dtype:"float32"}}),l=t.dataIdMap.get(I.dataId).id);var S=t.makeOutput(v,"float32");if(0!==n.util.sizeFromShape(d.shape)){var E=t.dataIdMap.get(S.dataId).id;xe(l,w,E)}if(h&&t.disposeData(p.dataId),i){var A=n.backend_util.expandShapeToKeepDim(S.shape,m);S.shape=A}return"float32"!==d.dtype&&t.disposeData(I.dataId),S}};var Oe,Ce={kernelName:n.Min,backendName:"wasm",setupFunc:function(e){Fe=e.wasm.cwrap(n.Min,null,["number, number, number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=a.axis,i=a.keepDims,s=r.x,o=t.dataIdMap.get(s.dataId).id,l=o,d=s,c=k(s,u,t),p=c.transposed,f=c.axes,m=c.originalAxes,h=c.inputWasTransposed;if(h){var b=t.dataIdMap.get(p.dataId).id;b!==o&&(d=p,l=b)}var _=d.shape.length;n.backend_util.assertAxesAreInnerMostDims("min",f,_);var y=n.backend_util.computeOutAndReduceShapes(d.shape,f),v=y[0],g=y[1],w=n.util.sizeFromShape(g),I=t.makeOutput(v,d.dtype);if(0!==n.util.sizeFromShape(d.shape)){var S=t.dataIdMap.get(I.dataId).id;Fe(l,w,S)}if(h&&t.disposeData(p.dataId),i){var E=n.backend_util.expandShapeToKeepDim(I.shape,m);I.shape=E}return I}},Re=p(n.Minimum,!1),De=p(n.Multiply,!0),Pe=d(n.Neg);function We(e,n){var t=new Int32Array(e.wasm.HEAPU8.buffer,n,4),r=t[0],a=t[1],u=t[2],i=t[3];return e.wasm._free(n),{pSelectedIndices:r,selectedSize:a,pSelectedScores:u,pValidOutputs:i}}var Be,Le={kernelName:n.NonMaxSuppressionV3,backendName:"wasm",setupFunc:function(e){Oe=e.wasm.cwrap(n.NonMaxSuppressionV3,"number",["number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,t=e.inputs,r=e.attrs,a=r.iouThreshold,u=r.maxOutputSize,i=r.scoreThreshold,s=t.boxes,o=t.scores,l=n.dataIdMap.get(s.dataId).id,d=n.dataIdMap.get(o.dataId).id,c=We(n,Oe(l,d,u,a,i)),p=c.pSelectedIndices,f=c.selectedSize,m=c.pSelectedScores,h=c.pValidOutputs;return n.wasm._free(m),n.wasm._free(h),n.makeOutput([f],"int32",p)}};var He,Ue={kernelName:n.NonMaxSuppressionV4,backendName:"wasm",setupFunc:function(e){Be=e.wasm.cwrap(n.NonMaxSuppressionV4,"number",["number","number","number","number","number","bool"])},kernelFunc:function(e){var n=e.backend,t=e.inputs,r=e.attrs,a=r.iouThreshold,u=r.maxOutputSize,i=r.scoreThreshold,s=r.padToMaxOutputSize,o=t.boxes,l=t.scores,d=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(l.dataId).id,p=We(n,Be(d,c,u,a,i,s)),f=p.pSelectedIndices,m=p.selectedSize,h=p.pSelectedScores,b=p.pValidOutputs;return n.wasm._free(h),[n.makeOutput([m],"int32",f),n.makeOutput([],"int32",b)]}};var ze,je={kernelName:n.NonMaxSuppressionV5,backendName:"wasm",setupFunc:function(e){He=e.wasm.cwrap(n.NonMaxSuppressionV5,"number",["number","number","number","number","number","number"])},kernelFunc:function(e){var n=e.backend,t=e.inputs,r=e.attrs,a=r.iouThreshold,u=r.maxOutputSize,i=r.scoreThreshold,s=r.softNmsSigma,o=t.boxes,l=t.scores,d=n.dataIdMap.get(o.dataId).id,c=n.dataIdMap.get(l.dataId).id,p=We(n,He(d,c,u,a,i,s)),f=p.pSelectedIndices,m=p.selectedSize,h=p.pSelectedScores,b=p.pValidOutputs;return n.wasm._free(b),[n.makeOutput([m],"int32",f),n.makeOutput([m],"float32",h)]}},qe=p(n.NotEqual,!1,"bool");var Ve={kernelName:n.OneHot,backendName:"wasm",setupFunc:function(e){ze=e.wasm.cwrap(n.OneHot,null,["number","number","number","number","number"])},kernelFunc:function(e){var n=e.inputs,t=e.backend,r=e.attrs,a=n.indices,u=r.depth,i=r.onValue,s=r.offValue,o=t.makeOutput(a.shape.concat([u]),"int32"),l=t.dataIdMap.get(o.dataId).id,d=t.dataIdMap.get(a.dataId).id;return ze(d,u,i,s,l),o}};var Ge={kernelName:n.OnesLike,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,t=e.backend,r=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(r).fill(1),r}};var Ke,Xe={kernelName:n.Pack,backendName:"wasm",kernelFunc:function(e){var t=e.inputs,r=e.backend,a=e.attrs.axis;if(1===t.length)return $({inputs:{input:t[0]},backend:r,attrs:{dim:a}});var u=t[0].shape,i=t[0].dtype;return t.forEach((function(e){n.util.assertShapesMatch(u,e.shape,"All tensors passed to stack must have matching shapes"),n.util.assert(i===e.dtype,(function(){return"All tensors passed to stack must have matching dtypes"}))})),D({inputs:t.map((function(e){return $({inputs:{input:e},backend:r,attrs:{dim:a}})})),backend:r,attrs:{axis:a}})}};var Ye,Qe={kernelName:n.PadV2,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,t=e.backend,r=e.attrs,a=r.paddings,u=r.constantValue,s=a.map((function(e,t){return e[0]+n.shape[t]+e[1]})),o=t.dataIdMap.get(n.dataId).id,l=t.makeOutput(s,n.dtype),d=t.dataIdMap.get(l.dataId).id,c=new Uint8Array(new Int32Array(n.shape).buffer),p=a.map((function(e){return e[0]})),f=a.map((function(e){return e[1]})),m=new Uint8Array(new Int32Array(p).buffer),h=new Uint8Array(new Int32Array(f).buffer);return Ke(o,c,n.shape.length,i[n.dtype],m,h,u,d),l},setupFunc:function(e){Ke=e.wasm.cwrap(n.PadV2,null,["number","array","number","number","array","array","number","number"])}},Ze=p(n.Pow,!1);var Je,$e={kernelName:n.Prelu,backendName:"wasm",setupFunc:function(e){Ye=e.wasm.cwrap(n.Prelu,null,["number","number","number"])},kernelFunc:function(e){var n=e.inputs,t=e.backend,r=n.x,a=n.alpha,u=t.dataIdMap.get(r.dataId).id,i=t.dataIdMap.get(a.dataId).id,s=t.makeOutput(r.shape,"float32"),o=t.dataIdMap.get(s.dataId).id;return Ye(u,i,o),s}};var en,nn={kernelName:n.Prod,backendName:"wasm",setupFunc:function(e){Je=e.wasm.cwrap(n.Prod,null,["number","number","number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=a.axis,s=a.keepDims,o=r.x,l=t.dataIdMap.get(o.dataId).id,d=l,c=o,p=k(o,u,t),f=p.transposed,m=p.axes,h=p.originalAxes,b=p.inputWasTransposed,_=m;if(b){var y=t.dataIdMap.get(f.dataId).id;y!==l&&(c=f,d=y,_=n.backend_util.getInnerMostAxes(_.length,c.shape.length))}n.backend_util.assertAxesAreInnerMostDims("prod",_,c.shape.length);var v=n.backend_util.computeOutAndReduceShapes(c.shape,_),g=v[0],w=v[1],I=n.util.sizeFromShape(w),S=t.makeOutput(g,c.dtype);if(0!==n.util.sizeFromShape(c.shape)){var E=t.dataIdMap.get(S.dataId).id;Je(d,I,i[S.dtype],E)}if(b&&t.disposeData(f.dataId),s){var A=n.backend_util.expandShapeToKeepDim(S.shape,h);S.shape=A}return S}},tn={kernelName:n.Range,backendName:"wasm",kernelFunc:function(e){var t=e.backend,r=e.attrs,a=r.start,u=r.stop,i=r.step,s=r.dtype,o=function(e,t,r,a){if(e===t||e<t&&r<0||t<e&&r>1)return n.util.makeZerosTypedArray(0,a);const u=Math.abs(Math.ceil((t-e)/r)),i=n.util.makeZerosTypedArray(u,a);t<e&&1===r&&(r=-1),i[0]=e;for(let e=1;e<i.length;e++)i[e]=i[e-1]+r;return i}(a,u,i,s),l=t.makeOutput([o.length],s);return t.typedArrayFromHeap(l).set(o),l}},rn=p(n.RealDiv,!0),an=d(n.Relu),un=d(n.Relu6);var sn,on={kernelName:n.ResizeBilinear,backendName:"wasm",setupFunc:function(e){en=e.wasm.cwrap(n.ResizeBilinear,null,["number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){var t,r=e.backend,a=e.inputs,u=e.attrs,i=a.images,s=u.alignCorners,o=u.halfPixelCenters,l=u.size,d=l[0],c=l[1],p=i.shape,f=p[0],m=p[1],h=p[2],b=p[3],_=[f,d,c,b],y=r.dataIdMap.get(i.dataId);"float32"!==y.dtype&&(t=F({backend:r,inputs:{x:i},attrs:{dtype:"float32"}}),y=r.dataIdMap.get(t.dataId));var v=y.id,g=r.makeOutput(_,"float32");if(0===n.util.sizeFromShape(i.shape))return g;var w=r.dataIdMap.get(g.dataId).id;return en(v,f,m,h,b,d,c,s?1:0,o?1:0,w),null!=t&&r.disposeData(t.dataId),g}};var ln,dn={kernelName:n.Reverse,backendName:"wasm",kernelFunc:function(e){var t=e.inputs,r=e.backend,a=e.attrs,u=t.x,i=a.dims,s=n.util.parseAxisParam(i,u.shape);if(0===u.shape.length)return b({inputs:{x:u},backend:r});var o=r.makeOutput(u.shape,u.dtype),l=r.dataIdMap.get(u.dataId).id,d=r.dataIdMap.get(o.dataId).id,c=new Uint8Array(new Int32Array(s).buffer),p=new Uint8Array(new Int32Array(u.shape).buffer);return sn(l,c,s.length,p,u.shape.length,d),A({inputs:{x:o},attrs:{shape:u.shape},backend:r})},setupFunc:function(e){sn=e.wasm.cwrap(n.Reverse,null,["number","array","number","array","number","number"])}};var cn,pn,fn,mn,hn={kernelName:n.RotateWithOffset,backendName:"wasm",kernelFunc:function(e){var t=e.inputs,r=e.backend,a=e.attrs,u=t.image,i=a.radians,s=a.fillValue,o=a.center,l=r.makeOutput(u.shape,u.dtype),d=r.dataIdMap.get(u.dataId).id,c=r.dataIdMap.get(l.dataId).id,p=u.shape,f=p[0],m=p[1],h=p[2],b=p[3],_=n.backend_util.getImageCenter(o,m,h),y=_[0],v=_[1],g="number"==typeof s?[s,s,s,0===s?0:255]:s.concat([255]),w=new Uint8Array(new Int32Array(g).buffer);return ln(d,f,m,h,b,i,y,v,w,g.length,c),l},setupFunc:function(e){ln=e.wasm.cwrap(n.RotateWithOffset,null,["number","number","number","number","number","number","number","number","array","number","number"])}},bn=d(n.Round);function _n(e){var t=e.inputs.x,r=e.attrs,a=r.begin,u=r.size,i=e.backend,s=n.slice_util.parseSliceParams(t,a,u),o=s[0],l=s[1],d=n.slice_util.isSliceContinous(t.shape,o,l),c=i.readSync(t.dataId),p=i.makeOutput(l,t.dtype),f=n.util.computeStrides(t.shape),m=i.dataIdMap.get(p.dataId);if(d){var h=n.slice_util.computeFlatOffset(o,f);if("string"===t.dtype)m.stringBytes=c.slice(h,h+n.util.sizeFromShape(l));else i.typedArrayFromHeap(p).set(c.subarray(h,h+n.util.sizeFromShape(l)));return p}if("string"===t.dtype){var b=R(c,o,l,t.shape,t.dtype);return m.stringBytes=b,p}var _=i.typedArrayFromHeap(p),y=t.shape.length;if(2===y)!function(e,n,t,r,a){for(var u=0,i=r[0],s=r[1],o=i+a[0],l=i;l<o;l++){var d=l*n+s;t.set(e.subarray(d,d+a[1]),u),u+=a[1]}}(c,f[0],_,o,l);else if(3===y)!function(e,n,t,r,a,u){for(var i=0,s=a[0],o=a[1],l=a[2],d=s+u[0],c=o+u[1],p=s;p<d;p++)for(var f=o;f<c;f++){var m=p*n+f*t+l;r.set(e.subarray(m,m+u[2]),i),i+=u[2]}}(c,f[0],f[1],_,o,l);else if(4===y)!function(e,n,t,r,a,u,i){for(var s=0,o=u[0],l=u[1],d=u[2],c=o+i[0],p=l+i[1],f=d+i[2],m=u[3],h=o;h<c;h++)for(var b=l;b<p;b++)for(var _=d;_<f;_++){var y=h*n+b*t+_*r+m;a.set(e.subarray(y,y+i[3]),s),s+=i[3]}}(c,f[0],f[1],f[2],_,o,l);else{b=R(c,o,l,t.shape,t.dtype);_.set(b)}return p}var yn,vn;var gn,wn,kn;for(var In=0,Sn=[c,m,h,S,E,N,O,C,W,L,z,j,V,K,Y,Q,Z,J,ee,te,ae,ue,ie,l,oe,de,pe,me,be,_e,ye,y,ge,we,ke,Ie,Se,Ae,Me,Ne,Te,Ce,Re,De,Pe,Le,Ue,je,qe,Ve,Ge,Xe,Qe,Ze,$e,nn,tn,rn,an,un,x,on,dn,hn,d(n.Rsqrt),bn,{kernelName:n.ScatterNd,backendName:"wasm",setupFunc:function(e){cn=e.wasm.cwrap(n.ScatterNd,null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=r.indices,s=r.updates,o=a.shape,l=t.makeOutput(o,s.dtype);if(0===n.util.sizeFromShape(o))return l;var d=n.scatter_util.calculateShapes(s,u,o),c=d.sliceRank,p=d.numUpdates,f=d.sliceSize,m=d.strides,h=d.outputSize,b=t.dataIdMap.get(u.dataId).id,_=t.dataIdMap.get(s.dataId).id,y=new Uint8Array(new Int32Array(m).buffer),v=t.dataIdMap.get(l.dataId).id;return cn(b,_,i[s.dtype],c,p,f,y,h,v),l}},{kernelName:n.Select,backendName:"wasm",kernelFunc:function(e){var t=e.inputs,r=e.backend,a=t.condition,u=t.t,i=t.e,s=r.dataIdMap.get(a.dataId).id,o=r.dataIdMap.get(u.dataId).id,l=r.dataIdMap.get(i.dataId).id,d=r.makeOutput(u.shape,u.dtype),c=r.dataIdMap.get(d.dataId).id,p=a.shape.length,f=u.shape.length,m=0===p||p>1||1===f?1:n.util.sizeFromShape(u.shape.slice(1));return pn(s,o,l,m,c),d},setupFunc:function(e){pn=e.wasm.cwrap("SelectV2",null,["number","number","number","number","number"])}},{kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){fn=e.wasm.cwrap(n.Sigmoid,null,["number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs.x,a=t.dataIdMap.get(r.dataId).id,u=t.makeOutput(r.shape,r.dtype),i=t.dataIdMap.get(u.dataId).id;return 0===n.util.sizeFromShape(u.shape)||fn(a,i),u}},d(n.Sin),{kernelName:n.Slice,backendName:"wasm",kernelFunc:_n},{kernelName:n.Softmax,backendName:"wasm",setupFunc:function(e){mn=e.wasm.cwrap(n.Softmax,null,["number","number","number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs.logits,a=e.attrs.dim,u=t.dataIdMap.get(r.dataId).id,i=t.makeOutput(r.shape,r.dtype),s=t.dataIdMap.get(i.dataId).id,o=r.shape[a],l=n.util.sizeFromShape(r.shape)/o;return 0===n.util.sizeFromShape(i.shape)||mn(u,s,o,l),i}},{kernelName:n.SplitV,backendName:"wasm",kernelFunc:function(e){var t=e.inputs,r=e.attrs,a=e.backend,u=t.x,i=r.numOrSizeSplits,s=r.axis,o=n.util.parseAxisParam(s,u.shape)[0],l=n.backend_util.prepareSplitSize(u,i,o),d=new Array(u.shape.length).fill(0),c=u.shape.slice();return l.map((function(e){var n=c.slice();n[o]=e;var t=_n({inputs:{x:u},attrs:{begin:d,size:n},backend:a});return d[o]+=e,t}))}},d(n.Sqrt),d(n.Square),p(n.SquaredDifference,!0),{kernelName:n.Step,backendName:"wasm",setupFunc:function(e){yn=e.wasm.cwrap(n.Step,null,["number","number","number"])},kernelFunc:function(e){var n=e.backend,t=e.inputs,r=e.attrs.alpha,a=t.x,u=n.dataIdMap.get(a.dataId).id,i=n.makeOutput(a.shape,a.dtype),s=n.dataIdMap.get(i.dataId).id;return yn(u,r,s),i}},{kernelName:n.StridedSlice,backendName:"wasm",setupFunc:function(e){vn=e.wasm.cwrap(n.StridedSlice,null,["number","array","number","array","array","array","array","array","number","number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=r.x,i=a.begin,s=a.end,o=a.strides;null==o&&(o=new Array(i.length));var l=a.beginMask,d=a.endMask,c=a.ellipsisMask,p=a.newAxisMask,f=a.shrinkAxisMask,m=n.backend_util.slice_util.maskToAxes(c);if(m.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==c&&0!==p)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==c&&0!==f)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");var h=u.shape.length-i.length,b=n.backend_util.slice_util.maskToAxes(p),_=u.shape.slice();b.forEach((function(e){i[e]=0,s[e]=1,_.splice(e,0,1)}));var y=A({inputs:{x:u},attrs:{shape:_},backend:t}),v=n.backend_util.slice_util.getNormalizedAxes(y.shape,m,h,i,s,o,l,d,c),g=v.begin,w=v.end,k=v.strides;i=g,s=w,o=k;var I=n.backend_util.slice_util.maskToAxes(f);I.forEach((function(e){s[e]=i[e]+1,o[e]=1}));var S=n.backend_util.slice_util.computeOutShape(i,s,o),E=S.filter((function(e,n){return-1===I.indexOf(n)}));if(o.every((function(e){return 1===e})))return A({inputs:{x:_n({inputs:{x:u},attrs:{begin:i,size:S},backend:t})},attrs:{shape:E},backend:t});var M=t.makeOutput(E,"float32");if(!E.some((function(e){return 0===e}))){var x=t.dataIdMap.get(y.dataId).id,N=new Uint8Array(new Int32Array(n.util.computeStrides(y.shape)).buffer),F=new Uint8Array(new Int32Array(i).buffer),T=new Uint8Array(new Int32Array(s).buffer),O=new Uint8Array(new Int32Array(o).buffer),C=new Uint8Array(new Int32Array(E).buffer),R=new Uint8Array(new Int32Array(n.util.computeStrides(E)).buffer),D=t.dataIdMap.get(M.dataId).id;vn(x,N,y.shape.length,F,T,O,C,R,E.length,D)}return A({inputs:{x:M},attrs:{shape:E},backend:t})}},p(n.Sub,!0),{kernelName:n.Sum,backendName:"wasm",setupFunc:function(e){gn=e.wasm.cwrap(n.Sum,null,["number, number, number"])},kernelFunc:function(e){var t=e.backend,r=e.inputs,a=e.attrs,u=a.axis,i=a.keepDims,s=r.x,o=t.dataIdMap.get(s.dataId).id,l=o,d=s,c=k(s,u,t),p=c.transposed,f=c.axes,m=c.originalAxes,h=c.inputWasTransposed,b=f;if(h){var _=t.dataIdMap.get(p.dataId).id;_!==o&&(d=p,l=_,b=n.backend_util.getInnerMostAxes(b.length,d.shape.length))}n.backend_util.assertAxesAreInnerMostDims("sum",b,d.shape.length);var y=n.backend_util.computeOutAndReduceShapes(d.shape,b),v=y[0],g=y[1],w=n.util.sizeFromShape(g),I=t.makeOutput(v,d.dtype);if(0!==n.util.sizeFromShape(d.shape)){var S=t.dataIdMap.get(I.dataId).id;gn(l,w,S)}if(h&&t.disposeData(p.dataId),i){var E=n.backend_util.expandShapeToKeepDim(I.shape,m);I.shape=E}return I}},d(n.Tanh),{kernelName:n.Tile,backendName:"wasm",setupFunc:function(e){wn=e.wasm.cwrap(n.Tile,null,["number","array","number","array","number","number"])},kernelFunc:function(e){for(var n=e.inputs,t=e.backend,r=e.attrs,a=n.x,u=t.dataIdMap.get(a.dataId).id,s=r.reps,o=new Array(a.shape.length),l=0;l<o.length;l++)o[l]=a.shape[l]*s[l];var d=new Uint8Array(new Int32Array(a.shape).buffer),c=new Uint8Array(new Int32Array(o).buffer),p=t.makeOutput(o,a.dtype),f=t.dataIdMap.get(p.dataId).id;return wn(u,d,a.shape.length,c,o.length,i[p.dtype],f),p}},{kernelName:n.TopK,backendName:"wasm",setupFunc:function(e){kn=e.wasm.cwrap(n.TopK,null,["number","array","number","number","number","bool","number","number"])},kernelFunc:function(e){var n=e.inputs,t=e.backend,r=e.attrs,a=n.x,u=r.k,s=r.sorted,o=t.dataIdMap.get(a.dataId).id,l=new Uint8Array(new Int32Array(a.shape).buffer),d=a.shape.slice();d[d.length-1]=u;var c=t.makeOutput(d,a.dtype),p=t.dataIdMap.get(c.dataId).id,f=t.makeOutput(d,"int32"),m=t.dataIdMap.get(f.dataId).id;return kn(o,l,a.shape.length,i[a.dtype],u,s,p,m),[c,f]}},w,{kernelName:n.Unpack,backendName:"wasm",kernelFunc:function(e){var n=e.inputs,t=e.backend,r=e.attrs,a=n.value,u=r.axis;u<0&&(u+=a.shape.length);for(var i=a.shape[u],s=a.shape.length,o=new Array(s-1),l=0,d=0;d<s;d++)d!==u&&(o[l++]=a.shape[d]);var c=new Array(i),p=new Array(s).fill(0),f=a.shape.slice();for(f[u]=1,d=0;d<c.length;d++)p[u]=d,c[d]=_n({inputs:{x:a},attrs:{begin:p,size:f},backend:t});return c.map((function(e){return{dataId:e.dataId,dtype:e.dtype,shape:o}}))}},{kernelName:n.ZerosLike,backendName:"wasm",kernelFunc:function(e){var n=e.inputs.x,t=e.backend,r=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(r).fill(0),r}}];In<Sn.length;In++){var En=Sn[In];n.registerKernel(En)}var An=function(e,n){return(An=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,n){e.__proto__=n}||function(e,n){for(var t in n)n.hasOwnProperty(t)&&(e[t]=n[t])})(e,n)};function Mn(e,n,t,r){return new(t||(t=Promise))((function(a,u){function i(e){try{o(r.next(e))}catch(e){u(e)}}function s(e){try{o(r.throw(e))}catch(e){u(e)}}function o(e){var n;e.done?a(e.value):(n=e.value,n instanceof t?n:new t((function(e){e(n)}))).then(i,s)}o((r=r.apply(e,n||[])).next())}))}function xn(e,n){var t,r,a,u,i={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return u={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u;function s(u){return function(s){return function(u){if(t)throw new TypeError("Generator is already executing.");for(;i;)try{if(t=1,r&&(a=2&u[0]?r.return:u[0]?r.throw||((a=r.return)&&a.call(r),0):r.next)&&!(a=a.call(r,u[1])).done)return a;switch(r=0,a&&(u=[2&u[0],a.value]),u[0]){case 0:case 1:a=u;break;case 4:return i.label++,{value:u[1],done:!1};case 5:i.label++,r=u[1],u=[0];continue;case 7:u=i.ops.pop(),i.trys.pop();continue;default:if(!(a=i.trys,(a=a.length>0&&a[a.length-1])||6!==u[0]&&2!==u[0])){i=0;continue}if(3===u[0]&&(!a||u[1]>a[0]&&u[1]<a[3])){i.label=u[1];break}if(6===u[0]&&i.label<a[1]){i.label=a[1],a=u;break}if(a&&i.label<a[2]){i.label=a[2],i.ops.push(u);break}a[2]&&i.ops.pop(),i.trys.pop();continue}u=n.call(e,i)}catch(e){u=[6,e],r=0}finally{t=a=0}if(5&u[0])throw u[1];return{value:u[0]?u[1]:void 0,done:!0}}([u,s])}}}var Nn=n.env();function Fn(e,n){return e(n={exports:{}},n.exports),n.exports}Nn.registerFlag("WASM_HAS_SIMD_SUPPORT",(function(){return Mn(void 0,void 0,void 0,(function(){return xn(this,(function(e){return[2,WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,10,9,1,7,0,65,0,253,15,26,11]))]}))}))})),Nn.registerFlag("WASM_HAS_MULTITHREAD_SUPPORT",(function(){return Mn(void 0,void 0,void 0,(function(){return xn(this,(function(e){if(Nn.get("IS_NODE"))return[2,!1];try{return(new MessageChannel).port1.postMessage(new SharedArrayBuffer(1)),[2,WebAssembly.validate(new Uint8Array([0,97,115,109,1,0,0,0,1,4,1,96,0,0,3,2,1,0,5,4,1,3,1,1,10,11,1,9,0,65,0,254,16,2,0,26,11]))]}catch(e){return[2,!1]}return[2]}))}))}));var Tn=Fn((function(e,n){var i,s=(i="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(i=i||__filename),function(e){function n(){return x.buffer!=V&&$(x.buffer),G}function s(){return x.buffer!=V&&$(x.buffer),K}function o(){return x.buffer!=V&&$(x.buffer),X}function l(){return x.buffer!=V&&$(x.buffer),Y}function d(){return x.buffer!=V&&$(x.buffer),Q}var c,p="undefined"!=typeof(e=e||{})?e:{},f={};for(c in p)p.hasOwnProperty(c)&&(f[c]=p[c]);var m=!1,h=!1,b=!1,_=!1;m="object"==typeof window,h="function"==typeof importScripts,b="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,_=!m&&!b&&!h;var y=p.ENVIRONMENT_IS_PTHREAD||!1;y&&(V=p.buffer,ee=p.DYNAMIC_BASE,ne=p.DYNAMICTOP_PTR);var v,g,w,k,I="";function S(e){return p.locateFile?p.locateFile(e,I):I+e}if(b){var E;I=h?t.dirname(I)+"/":__dirname+"/",v=function(e,n){return w||(w=r),k||(k=t),e=k.normalize(e),w.readFileSync(e,n?null:"utf8")},g=function(e){var n=v(e,!0);return n.buffer||(n=new Uint8Array(n)),D(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof pt))throw e})),process.on("unhandledRejection",we),p.inspect=function(){return"[Emscripten Module object]"};try{E=a}catch(e){throw console.error('The "worker_threads" module is not supported in this node.js build - perhaps a newer version is needed?'),e}Worker=E.Worker}else _?("undefined"!=typeof read&&(v=function(e){return read(e)}),g=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(D("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(m||h)&&(h?I=self.location.href:document.currentScript&&(I=document.currentScript.src),"undefined"!=typeof i&&i&&(I=i),I=0!==I.indexOf("blob:")?I.substr(0,I.lastIndexOf("/")+1):"",b?(v=function(e,n){return w||(w=r),k||(k=t),e=k.normalize(e),w.readFileSync(e,n?null:"utf8")},g=function(e){var n=v(e,!0);return n.buffer||(n=new Uint8Array(n)),D(n.buffer),n}):(v=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},h&&(g=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)})));b&&"undefined"==typeof performance&&(performance=u.performance);var A,M,x,N=p.print||console.log.bind(console),F=p.printErr||console.warn.bind(console);for(c in f)f.hasOwnProperty(c)&&(p[c]=f[c]);f=null,p.arguments&&p.arguments,p.thisProgram&&p.thisProgram,p.quit&&p.quit,p.wasmBinary&&(A=p.wasmBinary),p.noExitRuntime&&(M=p.noExitRuntime),"object"!=typeof WebAssembly&&F("no native wasm support detected");var T,O=new WebAssembly.Table({initial:169,maximum:169,element:"anyfunc"}),C=0,R=!1;function D(e,n){e||we("Assertion failed: "+n)}function P(e){var n=p["_"+e];return D(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function W(e,n,t,r,a){var u={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);z(e,n=lt(t),t)}return n},array:function(e){var n=lt(e.length);return q(e,n),n}},i=P(e),s=[],o=0;if(r)for(var l=0;l<r.length;l++){var d=u[t[l]];d?(0===o&&(o=ot()),s[l]=d(r[l])):s[l]=r[l]}var c=i.apply(null,s);return c=function(e){return"string"===n?H(e):"boolean"===n?Boolean(e):e}(c),0!==o&&dt(o),c}function B(e,n,t,r){var a=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&a&&!r?P(e):function(){return W(e,n,t,arguments)}}function L(e,n,t){for(var r=n+t,a="";!(n>=r);){var u=e[n++];if(!u)return a;if(128&u){var i=63&e[n++];if(192!=(224&u)){var s=63&e[n++];if((u=224==(240&u)?(15&u)<<12|i<<6|s:(7&u)<<18|i<<12|s<<6|63&e[n++])<65536)a+=String.fromCharCode(u);else{var o=u-65536;a+=String.fromCharCode(55296|o>>10,56320|1023&o)}}else a+=String.fromCharCode((31&u)<<6|i)}else a+=String.fromCharCode(u)}return a}function H(e,n){return e?L(s(),e,n):""}function U(e,n,t,r){if(!(r>0))return 0;for(var a=t,u=t+r-1,i=0;i<e.length;++i){var s=e.charCodeAt(i);if(s>=55296&&s<=57343&&(s=65536+((1023&s)<<10)|1023&e.charCodeAt(++i)),s<=127){if(t>=u)break;n[t++]=s}else if(s<=2047){if(t+1>=u)break;n[t++]=192|s>>6,n[t++]=128|63&s}else if(s<=65535){if(t+2>=u)break;n[t++]=224|s>>12,n[t++]=128|s>>6&63,n[t++]=128|63&s}else{if(t+3>=u)break;n[t++]=240|s>>18,n[t++]=128|s>>12&63,n[t++]=128|s>>6&63,n[t++]=128|63&s}}return n[t]=0,t-a}function z(e,n,t){return U(e,s(),n,t)}function j(e){for(var n=0,t=0;t<e.length;++t){var r=e.charCodeAt(t);r>=55296&&r<=57343&&(r=65536+((1023&r)<<10)|1023&e.charCodeAt(++t)),r<=127?++n:n+=r<=2047?2:r<=65535?3:4}return n}function q(e,t){n().set(e,t)}var V,G,K,X,Y,Q,Z=65536;function J(e,n){return e%n>0&&(e+=n-e%n),e}function $(e){V=e,p.HEAP8=G=new Int8Array(e),p.HEAP16=new Int16Array(e),p.HEAP32=X=new Int32Array(e),p.HEAPU8=K=new Uint8Array(e),p.HEAPU16=new Uint16Array(e),p.HEAPU32=Y=new Uint32Array(e),p.HEAPF32=new Float32Array(e),p.HEAPF64=Q=new Float64Array(e)}var ee=5256464,ne=12656,te=p.INITIAL_MEMORY||16777216;if(y)x=p.wasmMemory,V=p.buffer;else if(p.wasmMemory)x=p.wasmMemory;else if(!((x=new WebAssembly.Memory({initial:te/Z,maximum:2147483648/Z,shared:!0})).buffer instanceof SharedArrayBuffer))throw F("requested a shared WebAssembly.Memory but the returned buffer is not a SharedArrayBuffer, indicating that while the browser has SharedArrayBuffer it does not have WebAssembly threads support - you may need to set a flag"),b&&console.log("(on node you may need: --experimental-wasm-threads --experimental-wasm-bulk-memory and also use a recent version)"),Error("bad memory");function re(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?p.dynCall_v(t):p.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n(p)}}x&&(V=x.buffer),te=V.byteLength,$(V),y||(o()[ne>>2]=ee);var ae=[],ue=[],ie=[],se=[];function oe(){if(!y){if(p.preRun)for("function"==typeof p.preRun&&(p.preRun=[p.preRun]);p.preRun.length;)pe(p.preRun.shift());re(ae)}}function le(){re(ue)}function de(){y||re(ie)}function ce(){if(!y){if(p.postRun)for("function"==typeof p.postRun&&(p.postRun=[p.postRun]);p.postRun.length;)fe(p.postRun.shift());re(se)}}function pe(e){ae.unshift(e)}function fe(e){se.unshift(e)}var me=Math.ceil,he=Math.floor,be=0,_e=null,ye=null;function ve(e){D(!y,"addRunDependency cannot be used in a pthread worker"),be++,p.monitorRunDependencies&&p.monitorRunDependencies(be)}function ge(e){if(be--,p.monitorRunDependencies&&p.monitorRunDependencies(be),0==be&&(null!==_e&&(clearInterval(_e),_e=null),ye)){var n=ye;ye=null,n()}}function we(e){throw p.onAbort&&p.onAbort(e),y&&console.error("Pthread aborting at "+(new Error).stack),N(e+=""),F(e),R=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}function ke(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}p.preloadedImages={},p.preloadedAudios={};var Ie="data:application/octet-stream;base64,";function Se(e){return ke(e,Ie)}var Ee="file://";function Ae(e){return ke(e,Ee)}var Me="tfjs-backend-wasm-threaded-simd.wasm";function xe(){try{if(A)return new Uint8Array(A);if(g)return g(Me);throw"both async and sync fetching of the wasm failed"}catch(e){we(e)}}function Ne(){return A||!m&&!h||"function"!=typeof fetch||Ae(Me)?new Promise((function(e,n){e(xe())})):fetch(Me,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+Me+"'";return e.arrayBuffer()})).catch((function(){return xe()}))}function Fe(){var e={a:Kn};function n(e,n){var t=e.exports;if(p.asm=t,T=n,!y){var r=qe.unusedWorkers.length;qe.unusedWorkers.forEach((function(e){qe.loadWasmModuleToWorker(e,(function(){--r||ge()}))}))}}function t(e){n(e.instance,e.module)}function r(n){return Ne().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){F("failed to asynchronously prepare wasm: "+e),we(e)}))}if(y||ve(),p.instantiateWasm)try{return p.instantiateWasm(e,n)}catch(e){return F("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(A||"function"!=typeof WebAssembly.instantiateStreaming||Se(Me)||Ae(Me)||"function"!=typeof fetch)return r(t);fetch(Me,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){F("wasm streaming compile failed: "+e),F("falling back to ArrayBuffer instantiation"),r(t)}))}))}(),{}}Se(Me)||(Me=S(Me));var Te={};function Oe(){qe.initRuntime()}y||ue.push({func:function(){Qn()}});var Ce=0,Re=0,De=0;function Pe(e,n,t){Ce=e|=0,De=n|=0,Re=t|=0}p.__register_pthread_ptr=Pe;var We={EPERM:63,ENOENT:44,ESRCH:71,EINTR:27,EIO:29,ENXIO:60,E2BIG:1,ENOEXEC:45,EBADF:8,ECHILD:12,EAGAIN:6,EWOULDBLOCK:6,ENOMEM:48,EACCES:2,EFAULT:21,ENOTBLK:105,EBUSY:10,EEXIST:20,EXDEV:75,ENODEV:43,ENOTDIR:54,EISDIR:31,EINVAL:28,ENFILE:41,EMFILE:33,ENOTTY:59,ETXTBSY:74,EFBIG:22,ENOSPC:51,ESPIPE:70,EROFS:69,EMLINK:34,EPIPE:64,EDOM:18,ERANGE:68,ENOMSG:49,EIDRM:24,ECHRNG:106,EL2NSYNC:156,EL3HLT:107,EL3RST:108,ELNRNG:109,EUNATCH:110,ENOCSI:111,EL2HLT:112,EDEADLK:16,ENOLCK:46,EBADE:113,EBADR:114,EXFULL:115,ENOANO:104,EBADRQC:103,EBADSLT:102,EDEADLOCK:16,EBFONT:101,ENOSTR:100,ENODATA:116,ETIME:117,ENOSR:118,ENONET:119,ENOPKG:120,EREMOTE:121,ENOLINK:47,EADV:122,ESRMNT:123,ECOMM:124,EPROTO:65,EMULTIHOP:36,EDOTDOT:125,EBADMSG:9,ENOTUNIQ:126,EBADFD:127,EREMCHG:128,ELIBACC:129,ELIBBAD:130,ELIBSCN:131,ELIBMAX:132,ELIBEXEC:133,ENOSYS:52,ENOTEMPTY:55,ENAMETOOLONG:37,ELOOP:32,EOPNOTSUPP:138,EPFNOSUPPORT:139,ECONNRESET:15,ENOBUFS:42,EAFNOSUPPORT:5,EPROTOTYPE:67,ENOTSOCK:57,ENOPROTOOPT:50,ESHUTDOWN:140,ECONNREFUSED:14,EADDRINUSE:3,ECONNABORTED:13,ENETUNREACH:40,ENETDOWN:38,ETIMEDOUT:73,EHOSTDOWN:142,EHOSTUNREACH:23,EINPROGRESS:26,EALREADY:7,EDESTADDRREQ:17,EMSGSIZE:35,EPROTONOSUPPORT:66,ESOCKTNOSUPPORT:137,EADDRNOTAVAIL:4,ENETRESET:39,EISCONN:30,ENOTCONN:53,ETOOMANYREFS:141,EUSERS:136,EDQUOT:19,ESTALE:72,ENOTSUP:138,ENOMEDIUM:148,EILSEQ:25,EOVERFLOW:61,ECANCELED:11,ENOTRECOVERABLE:56,EOWNERDEAD:62,ESTRPIPE:135},Be=13568;function Le(e,t){if(e<=0||e>n().length||!0&e||t<0)return-28;if(0==t)return 0;t>=2147483647&&(t=1/0);var r=Atomics.load(o(),Be>>2),a=0;if(r==e&&Atomics.compareExchange(o(),Be>>2,r,0)==r&&(a=1,--t<=0))return 1;var u=Atomics.notify(o(),e>>2,t);if(u>=0)return u+a;throw"Atomics.notify returned an unexpected value "+u}function He(e){if(y)throw"Internal Error! _kill_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _kill_thread!";o()[e+12>>2]=0;var n=qe.pthreads[e];n.worker.terminate(),qe.freeThreadData(n),qe.runningWorkers.splice(qe.runningWorkers.indexOf(n.worker),1),n.worker.pthread=void 0}function Ue(e){if(y)throw"Internal Error! _cancel_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _cancel_thread!";qe.pthreads[e].worker.postMessage({cmd:"cancel"})}function ze(e){if(y)throw"Internal Error! _cleanup_thread() can only ever be called from main application thread!";if(!e)throw"Internal Error! Null pthread_ptr in _cleanup_thread!";o()[e+12>>2]=0;var n=qe.pthreads[e];if(n){var t=n.worker;qe.returnWorkerToPool(t)}}p._emscripten_futex_wake=Le;var je,qe={MAIN_THREAD_ID:1,mainThreadInfo:{schedPolicy:0,schedPrio:0},unusedWorkers:[],runningWorkers:[],initRuntime:function(){Pe(qe.mainThreadBlock,!h,1),at(qe.mainThreadBlock)},initMainThreadBlock:function(){for(var e=0;e<8;++e)qe.allocateUnusedWorker();for(qe.mainThreadBlock=12816,e=0;e<58;++e)l()[qe.mainThreadBlock/4+e]=0;o()[qe.mainThreadBlock+12>>2]=qe.mainThreadBlock;var n=qe.mainThreadBlock+156;for(o()[n>>2]=n,e=0;e<128;++e)l()[3264+e]=0;Atomics.store(l(),qe.mainThreadBlock+104>>2,13056),Atomics.store(l(),qe.mainThreadBlock+40>>2,qe.mainThreadBlock),Atomics.store(l(),qe.mainThreadBlock+44>>2,42)},initWorker:function(){},pthreads:{},exitHandlers:null,setThreadStatus:function(){},runExitHandlers:function(){if(null!==qe.exitHandlers){for(;qe.exitHandlers.length>0;)qe.exitHandlers.pop()();qe.exitHandlers=null}y&&C&&tt()},threadExit:function(e){var n=zn();n&&(Atomics.store(l(),n+4>>2,e),Atomics.store(l(),n+0>>2,1),Atomics.store(l(),n+60>>2,1),Atomics.store(l(),n+64>>2,0),qe.runExitHandlers(),Le(n+0,2147483647),Pe(0,0,0),C=0,y&&postMessage({cmd:"exit"}))},threadCancel:function(){qe.runExitHandlers(),Atomics.store(l(),C+4>>2,-1),Atomics.store(l(),C+0>>2,1),Le(C+0,2147483647),C=0,Pe(0,0,0),postMessage({cmd:"cancelDone"})},terminateAllThreads:function(){for(var e in qe.pthreads)(r=qe.pthreads[e])&&r.worker&&qe.returnWorkerToPool(r.worker);qe.pthreads={};for(var n=0;n<qe.unusedWorkers.length;++n)(t=qe.unusedWorkers[n]).terminate();for(qe.unusedWorkers=[],n=0;n<qe.runningWorkers.length;++n){var t,r=(t=qe.runningWorkers[n]).pthread;qe.freeThreadData(r),t.terminate()}qe.runningWorkers=[]},freeThreadData:function(e){if(e){if(e.threadInfoStruct){var n=o()[e.threadInfoStruct+104>>2];o()[e.threadInfoStruct+104>>2]=0,Jn(n),Jn(e.threadInfoStruct)}e.threadInfoStruct=0,e.allocatedOwnStack&&e.stackBase&&Jn(e.stackBase),e.stackBase=0,e.worker&&(e.worker.pthread=null)}},returnWorkerToPool:function(e){delete qe.pthreads[e.pthread.thread],qe.unusedWorkers.push(e),qe.runningWorkers.splice(qe.runningWorkers.indexOf(e),1),qe.freeThreadData(e.pthread),e.pthread=void 0},receiveObjectTransfer:function(e){},loadWasmModuleToWorker:function(e,n){e.onmessage=function(t){var r=t.data,a=r.cmd;if(e.pthread&&(qe.currentProxiedOperationCallerThread=e.pthread.threadInfoStruct),r.targetThread&&r.targetThread!=zn()){var u=qe.pthreads[r.targetThread];return u?u.worker.postMessage(t.data,r.transferList):console.error('Internal error! Worker sent a message "'+a+'" to target pthread '+r.targetThread+", but that thread no longer exists!"),void(qe.currentProxiedOperationCallerThread=void 0)}"processQueuedMainThreadWork"===a?rt():"spawnThread"===a?Hn(t.data):"cleanupThread"===a?ze(r.thread):"killThread"===a?He(r.thread):"cancelThread"===a?Ue(r.thread):"loaded"===a?(e.loaded=!0,n&&n(e),e.runPthread&&(e.runPthread(),delete e.runPthread)):"print"===a?N("Thread "+r.threadId+": "+r.text):"printErr"===a?F("Thread "+r.threadId+": "+r.text):"alert"===a?alert("Thread "+r.threadId+": "+r.text):"exit"===a?e.pthread&&Atomics.load(l(),e.pthread.thread+68>>2)&&qe.returnWorkerToPool(e):"cancelDone"===a?qe.returnWorkerToPool(e):"objectTransfer"===a?qe.receiveObjectTransfer(t.data):"setimmediate"===t.data.target?e.postMessage(t.data):F("worker sent an unknown command "+a),qe.currentProxiedOperationCallerThread=void 0},e.onerror=function(e){F("pthread sent an error! "+e.filename+":"+e.lineno+": "+e.message)},b&&(e.on("message",(function(n){e.onmessage({data:n})})),e.on("error",(function(n){e.onerror(n)})),e.on("exit",(function(e){console.log("worker exited - TODO: update the worker queue?")}))),e.postMessage({cmd:"load",urlOrBlob:p.mainScriptUrlOrBlob||i,wasmMemory:x,wasmModule:T,DYNAMIC_BASE:ee,DYNAMICTOP_PTR:ne})},allocateUnusedWorker:function(){var e=S("tfjs-backend-wasm-threaded-simd.worker.js");qe.unusedWorkers.push(new Worker(e))},getNewWorker:function(){return 0==qe.unusedWorkers.length&&(qe.allocateUnusedWorker(),qe.loadWasmModuleToWorker(qe.unusedWorkers[0])),qe.unusedWorkers.length>0?qe.unusedWorkers.pop():null},busySpinWait:function(e){for(var n=performance.now()+e;performance.now()<n;);}};function Ve(e,n){dt(e)}function Ge(){return M}function Ke(e,n,t,r){we("Assertion failed: "+H(e)+", at: "+[n?H(n):"unknown filename",t,r?H(r):"unknown function"])}function Xe(e,n){_main(e,n)}function Ye(e){return o()[$n()>>2]=e,e}function Qe(e,n){if(y)return un(1,1,e,n)}function Ze(e,n){if(e==n)postMessage({cmd:"processQueuedMainThreadWork"});else if(y)postMessage({targetThread:e,cmd:"processThreadQueue"});else{var t=qe.pthreads[e],r=t&&t.worker;if(!r)return;r.postMessage({cmd:"processThreadQueue"})}return 1}function Je(){we()}function $e(e,n){}function en(e,t,r){if(e<=0||e>n().length||!0&e)return-28;if(h){var a=Atomics.wait(o(),e>>2,t,r);if("timed-out"===a)return-73;if("not-equal"===a)return-6;if("ok"===a)return 0;throw"Atomics.wait returned an unexpected value "+a}if(t!=Atomics.load(o(),e>>2))return-6;var u=performance.now(),i=u+r;Atomics.store(o(),Be>>2,e);for(var s=e;e==s;){if((u=performance.now())>i)return-73;rt(),e=Atomics.load(o(),Be>>2)}return 0}function nn(){return 0|De}function tn(){return 0|Re}function rn(e,n,t){s().copyWithin(e,n,n+t)}function an(){return navigator.hardwareConcurrency}function un(e,n){for(var t=arguments.length-2,r=ot(),a=lt(8*t),u=a>>3,i=0;i<t;i++)d()[u+i]=arguments[2+i];var s=it(e,t,a,n);return dt(r),s}p.establishStackSpace=Ve,p.getNoExitRuntime=Ge,je=b?function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:y?function(){return performance.now()-p.__performance_now_clock_drift}:"undefined"!=typeof dateNow?dateNow:function(){return performance.now()};var sn=[];function on(e,n){on.array||(on.array=[]);var t,r=on.array;for(r.length=0;t=s()[e++];)100===t||102===t?(n=n+7&-8,r.push(d()[n>>3]),n+=8):(n=n+3&-4,r.push(o()[n>>2]),n+=4);return r}function ln(e,n,t){sn.length=n;for(var r=t>>3,a=0;a<n;a++)sn[a]=d()[r+a];var u=e<0,i=u?Te[-e-1]:Gn[e];if(u){var s=on(sn[1],sn[2]);return i.apply(null,s)}return i.apply(null,sn)}function dn(){return s().length}function cn(e){try{return x.grow(e-V.byteLength+65535>>>16),$(x.buffer),1}catch(e){}}function pn(e){e>>>=0;var n=dn();if(e<=n)return!1;if(e>2147483648)return!1;for(var t=1;t<=4;t*=2){var r=n*(1+.2/t);if(r=Math.min(r,e+100663296),cn(Math.min(2147483648,J(Math.max(16777216,e,r),65536))))return!0}return!1}var fn={keyEvent:0,mouseEvent:0,wheelEvent:0,uiEvent:0,focusEvent:0,deviceOrientationEvent:0,deviceMotionEvent:0,fullscreenChangeEvent:0,pointerlockChangeEvent:0,visibilityChangeEvent:0,touchEvent:0,previousFullscreenElement:null,previousScreenX:null,previousScreenY:null,removeEventListenersRegistered:!1,removeAllEventListeners:function(){for(var e=fn.eventHandlers.length-1;e>=0;--e)fn._removeHandler(e);fn.eventHandlers=[],fn.deferredCalls=[]},registerRemoveEventListeners:function(){fn.removeEventListenersRegistered||(fn.removeEventListenersRegistered=!0)},deferredCalls:[],deferCall:function(e,n,t){function r(e,n){if(e.length!=n.length)return!1;for(var t in e)if(e[t]!=n[t])return!1;return!0}for(var a in fn.deferredCalls){var u=fn.deferredCalls[a];if(u.targetFunction==e&&r(u.argsList,t))return}fn.deferredCalls.push({targetFunction:e,precedence:n,argsList:t}),fn.deferredCalls.sort((function(e,n){return e.precedence<n.precedence}))},removeDeferredCalls:function(e){for(var n=0;n<fn.deferredCalls.length;++n)fn.deferredCalls[n].targetFunction==e&&(fn.deferredCalls.splice(n,1),--n)},canPerformEventHandlerRequests:function(){return fn.inEventHandler&&fn.currentEventHandler.allowsDeferredCalls},runDeferredCalls:function(){if(fn.canPerformEventHandlerRequests())for(var e=0;e<fn.deferredCalls.length;++e){var n=fn.deferredCalls[e];fn.deferredCalls.splice(e,1),--e,n.targetFunction.apply(null,n.argsList)}},inEventHandler:0,currentEventHandler:null,eventHandlers:[],removeAllHandlersOnTarget:function(e,n){for(var t=0;t<fn.eventHandlers.length;++t)fn.eventHandlers[t].target!=e||n&&n!=fn.eventHandlers[t].eventTypeString||fn._removeHandler(t--)},_removeHandler:function(e){var n=fn.eventHandlers[e];n.target.removeEventListener(n.eventTypeString,n.eventListenerFunc,n.useCapture),fn.eventHandlers.splice(e,1)},registerOrRemoveHandler:function(e){var n=function(n){++fn.inEventHandler,fn.currentEventHandler=e,fn.runDeferredCalls(),e.handlerFunc(n),fn.runDeferredCalls(),--fn.inEventHandler};if(e.callbackfunc)e.eventListenerFunc=n,e.target.addEventListener(e.eventTypeString,n,e.useCapture),fn.eventHandlers.push(e),fn.registerRemoveEventListeners();else for(var t=0;t<fn.eventHandlers.length;++t)fn.eventHandlers[t].target==e.target&&fn.eventHandlers[t].eventTypeString==e.eventTypeString&&fn._removeHandler(t--)},queueEventHandlerOnThread_iiii:function(e,n,t,r,a){var u=ot(),i=lt(12);o()[i>>2]=t,o()[i+4>>2]=r,o()[i+8>>2]=a,st(e,637534208,n,r,i),dt(u)},getTargetThreadForEventCallback:function(e){switch(e){case 1:return 0;case 2:return qe.currentProxiedOperationCallerThread;default:return e}},getNodeNameForTarget:function(e){return e?e==window?"#window":e==screen?"#screen":e&&e.nodeName?e.nodeName:"":""},fullscreenEnabled:function(){return document.fullscreenEnabled||document.webkitFullscreenEnabled}};function mn(e){var n=j(e)+1,t=Zn(n);return z(e,t,n),t}function hn(e,n,t,r){var a=ot(),u=lt(12),i=0;n&&(i=mn(n)),o()[u>>2]=i,o()[u+4>>2]=t,o()[u+8>>2]=r,st(e,657457152,0,i,u),dt(a)}function bn(e,n,t,r){hn(e,n=n?H(n):"",t,r)}function _n(e){return e>2?H(e):e}var yn=[0,"undefined"!=typeof document?document:0,"undefined"!=typeof window?window:0];function vn(e){return e=_n(e),yn[e]||("undefined"!=typeof document?document.querySelector(e):void 0)}function gn(e){return vn(e)}function wn(e,n,t){var r=gn(e);if(!r)return-4;if(r.canvasSharedPtr&&(o()[r.canvasSharedPtr>>2]=n,o()[r.canvasSharedPtr+4>>2]=t),!r.offscreenCanvas&&r.controlTransferredOffscreen)return r.canvasSharedPtr?(bn(o()[r.canvasSharedPtr+8>>2],e,n,t),1):-4;r.offscreenCanvas&&(r=r.offscreenCanvas);var a=!1;if(r.GLctxObject&&r.GLctxObject.GLctx){var u=r.GLctxObject.GLctx.getParameter(2978);a=0===u[0]&&0===u[1]&&u[2]===r.width&&u[3]===r.height}return r.width=n,r.height=t,a&&r.GLctxObject.GLctx.viewport(0,0,n,t),0}function kn(e,n,t){return y?un(2,1,e,n,t):wn(e,n,t)}function In(e,n,t){return gn(e)?wn(e,n,t):kn(e,n,t)}function Sn(e){}function En(e,n){}function An(e){var n=e.getExtension("ANGLE_instanced_arrays");if(n)return e.vertexAttribDivisor=function(e,t){n.vertexAttribDivisorANGLE(e,t)},e.drawArraysInstanced=function(e,t,r,a){n.drawArraysInstancedANGLE(e,t,r,a)},e.drawElementsInstanced=function(e,t,r,a,u){n.drawElementsInstancedANGLE(e,t,r,a,u)},1}function Mn(e){var n=e.getExtension("OES_vertex_array_object");if(n)return e.createVertexArray=function(){return n.createVertexArrayOES()},e.deleteVertexArray=function(e){n.deleteVertexArrayOES(e)},e.bindVertexArray=function(e){n.bindVertexArrayOES(e)},e.isVertexArray=function(e){return n.isVertexArrayOES(e)},1}function xn(e){var n=e.getExtension("WEBGL_draw_buffers");if(n)return e.drawBuffers=function(e,t){n.drawBuffersWEBGL(e,t)},1}var Nn={counter:1,lastError:0,buffers:[],mappedBuffers:{},programs:[],framebuffers:[],renderbuffers:[],textures:[],uniforms:[],shaders:[],vaos:[],contexts:{},currentContext:null,offscreenCanvases:{},timerQueriesEXT:[],programInfos:{},stringCache:{},unpackAlignment:4,init:function(){for(var e=new Float32Array(Nn.MINI_TEMP_BUFFER_SIZE),n=0;n<Nn.MINI_TEMP_BUFFER_SIZE;n++)Nn.miniTempBufferFloatViews[n]=e.subarray(0,n+1);var t=new Int32Array(Nn.MINI_TEMP_BUFFER_SIZE);for(n=0;n<Nn.MINI_TEMP_BUFFER_SIZE;n++)Nn.miniTempBufferIntViews[n]=t.subarray(0,n+1)},recordError:function(e){Nn.lastError||(Nn.lastError=e)},getNewId:function(e){for(var n=Nn.counter++,t=e.length;t<n;t++)e[t]=null;return n},MINI_TEMP_BUFFER_SIZE:256,miniTempBufferFloatViews:[0],miniTempBufferIntViews:[0],getSource:function(e,n,t,r){for(var a="",u=0;u<n;++u){var i=r?o()[r+4*u>>2]:-1;a+=H(o()[t+4*u>>2],i<0?void 0:i)}return a},createContext:function(e,n){var t=e.getContext("webgl",n);return t?Nn.registerContext(t,n):0},registerContext:function(e,n){var t=Zn(8);o()[t+4>>2]=zn();var r={handle:t,attributes:n,version:n.majorVersion,GLctx:e};return e.canvas&&(e.canvas.GLctxObject=r),Nn.contexts[t]=r,("undefined"==typeof n.enableExtensionsByDefault||n.enableExtensionsByDefault)&&Nn.initExtensions(r),t},makeContextCurrent:function(e){return Nn.currentContext=Nn.contexts[e],p.ctx=Cn=Nn.currentContext&&Nn.currentContext.GLctx,!(e&&!Cn)},getContext:function(e){return Nn.contexts[e]},deleteContext:function(e){Nn.currentContext===Nn.contexts[e]&&(Nn.currentContext=null),"object"==typeof fn&&fn.removeAllHandlersOnTarget(Nn.contexts[e].GLctx.canvas),Nn.contexts[e]&&Nn.contexts[e].GLctx.canvas&&(Nn.contexts[e].GLctx.canvas.GLctxObject=void 0),Jn(Nn.contexts[e].handle),Nn.contexts[e]=null},initExtensions:function(e){if(e||(e=Nn.currentContext),!e.initExtensionsDone){e.initExtensionsDone=!0;var n=e.GLctx;An(n),Mn(n),xn(n),n.disjointTimerQueryExt=n.getExtension("EXT_disjoint_timer_query");var t=["OES_texture_float","OES_texture_half_float","OES_standard_derivatives","OES_vertex_array_object","WEBGL_compressed_texture_s3tc","WEBGL_depth_texture","OES_element_index_uint","EXT_texture_filter_anisotropic","EXT_frag_depth","WEBGL_draw_buffers","ANGLE_instanced_arrays","OES_texture_float_linear","OES_texture_half_float_linear","EXT_blend_minmax","EXT_shader_texture_lod","EXT_texture_norm16","WEBGL_compressed_texture_pvrtc","EXT_color_buffer_half_float","WEBGL_color_buffer_float","EXT_sRGB","WEBGL_compressed_texture_etc1","EXT_disjoint_timer_query","WEBGL_compressed_texture_etc","WEBGL_compressed_texture_astc","EXT_color_buffer_float","WEBGL_compressed_texture_s3tc_srgb","EXT_disjoint_timer_query_webgl2","WEBKIT_WEBGL_compressed_texture_pvrtc"];(n.getSupportedExtensions()||[]).forEach((function(e){-1!=t.indexOf(e)&&n.getExtension(e)}))}},populateUniformTable:function(e){for(var n=Nn.programs[e],t=Nn.programInfos[e]={uniforms:{},maxUniformLength:0,maxAttributeLength:-1,maxUniformBlockNameLength:-1},r=t.uniforms,a=Cn.getProgramParameter(n,35718),u=0;u<a;++u){var i=Cn.getActiveUniform(n,u),s=i.name;t.maxUniformLength=Math.max(t.maxUniformLength,s.length+1),"]"==s.slice(-1)&&(s=s.slice(0,s.lastIndexOf("[")));var o=Cn.getUniformLocation(n,s);if(o){var l=Nn.getNewId(Nn.uniforms);r[s]=[i.size,l],Nn.uniforms[l]=o;for(var d=1;d<i.size;++d){var c=s+"["+d+"]";o=Cn.getUniformLocation(n,c),l=Nn.getNewId(Nn.uniforms),Nn.uniforms[l]=o}}}}},Fn=["default","low-power","high-performance"];function Tn(e,n){var t={},r=n>>2;t.alpha=!!o()[r+0],t.depth=!!o()[r+1],t.stencil=!!o()[r+2],t.antialias=!!o()[r+3],t.premultipliedAlpha=!!o()[r+4],t.preserveDrawingBuffer=!!o()[r+5];var a=o()[r+6];t.powerPreference=Fn[a],t.failIfMajorPerformanceCaveat=!!o()[r+7],t.majorVersion=o()[r+8],t.minorVersion=o()[r+9],t.enableExtensionsByDefault=o()[r+10],t.explicitSwapControl=o()[r+11],t.proxyContextToMainThread=o()[r+12],t.renderViaOffscreenBackBuffer=o()[r+13];var u=gn(e);return u?t.explicitSwapControl?-1:Nn.createContext(u,t):-4}function On(e,n){return Tn(e,n)}var Cn,Rn={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=Rn.buffers[e];0===n||10===n?((1===e?N:F)(L(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return Rn.varargs+=4,o()[Rn.varargs-4>>2]},getStr:function(e){return H(e)},get64:function(e,n){return e}};function Dn(e){return y?un(3,1,e):0}function Pn(e,n,t,r,a){if(y)return un(4,1,e,n,t,r,a)}function Wn(e,n,t,r){if(y)return un(5,1,e,n,t,r);for(var a=0,u=0;u<t;u++){for(var i=o()[n+8*u>>2],l=o()[n+(8*u+4)>>2],d=0;d<l;d++)Rn.printChar(e,s()[i+d]);a+=l}return o()[r>>2]=a,0}function Bn(e){var n=qe.exitHandlers.pop();e&&n()}function Ln(e,n){null===qe.exitHandlers&&(qe.exitHandlers=[]),qe.exitHandlers.push((function(){ct(e,n)}))}function Hn(e){if(y)throw"Internal Error! _spawn_thread() can only ever be called from main application thread!";var n=qe.getNewWorker();if(void 0!==n.pthread)throw"Internal error!";if(!e.pthread_ptr)throw"Internal error, no pthread ptr!";qe.runningWorkers.push(n);for(var t=Zn(512),r=0;r<128;++r)o()[t+4*r>>2]=0;var a=e.stackBase+e.stackSize,u=qe.pthreads[e.pthread_ptr]={worker:n,stackBase:e.stackBase,stackSize:e.stackSize,allocatedOwnStack:e.allocatedOwnStack,thread:e.pthread_ptr,threadInfoStruct:e.pthread_ptr},i=u.threadInfoStruct>>2;Atomics.store(l(),i+0,0),Atomics.store(l(),i+1,0),Atomics.store(l(),i+2,0),Atomics.store(l(),i+17,e.detached),Atomics.store(l(),i+26,t),Atomics.store(l(),i+12,0),Atomics.store(l(),i+10,u.threadInfoStruct),Atomics.store(l(),i+11,42),Atomics.store(l(),i+27,e.stackSize),Atomics.store(l(),i+21,e.stackSize),Atomics.store(l(),i+20,a),Atomics.store(l(),i+29,a),Atomics.store(l(),i+30,e.detached),Atomics.store(l(),i+32,e.schedPolicy),Atomics.store(l(),i+33,e.schedPrio);var s=et()+40;Atomics.store(l(),i+44,s),n.pthread=u;var d={cmd:"run",start_routine:e.startRoutine,arg:e.arg,threadInfoStruct:e.pthread_ptr,selfThreadId:e.pthread_ptr,parentThreadId:e.parent_pthread_ptr,stackBase:e.stackBase,stackSize:e.stackSize};n.runPthread=function(){d.time=performance.now(),n.postMessage(d,e.transferList)},n.loaded&&(n.runPthread(),delete n.runPthread)}function Un(e,n,t){if(!n&&!t)return We.EINVAL;if(!e)return F("pthread_getschedparam called with a null thread pointer!"),We.ESRCH;if(o()[e+12>>2]!==e)return F("pthread_getschedparam attempted on thread "+e+", which does not point to a valid thread, or does not exist anymore!"),We.ESRCH;var r=Atomics.load(l(),e+108+20>>2),a=Atomics.load(l(),e+108+24>>2);return n&&(o()[n>>2]=r),t&&(o()[t>>2]=a),0}function zn(){return 0|Ce}function jn(e,n,t,r){if("undefined"==typeof SharedArrayBuffer)return F("Current environment does not support SharedArrayBuffer, pthreads are not available!"),6;if(!e)return F("pthread_create called with a null thread pointer!"),28;var a=[];if(y&&0===a.length)return ut(687865856,e,n,t,r);var u=0,i=0,s=0,d=0,c=0;if(n)if(u=o()[n>>2],u+=81920,i=o()[n+8>>2],s=0!==o()[n+12>>2],0===o()[n+16>>2]){var p=o()[n+20>>2],f=o()[n+24>>2];Un(qe.currentProxiedOperationCallerThread?qe.currentProxiedOperationCallerThread:zn(),n+20,n+24),d=o()[n+20>>2],c=o()[n+24>>2],o()[n+20>>2]=p,o()[n+24>>2]=f}else d=o()[n+20>>2],c=o()[n+24>>2];else u=2097152;var m=0==i;m?i=nt(16,u):D((i-=u)>0);for(var h=Zn(232),b=0;b<58;++b)l()[(h>>2)+b]=0;o()[e>>2]=h,o()[h+12>>2]=h;var _=h+156;o()[_>>2]=_;var v={stackBase:i,stackSize:u,allocatedOwnStack:m,schedPolicy:d,schedPrio:c,detached:s,startRoutine:t,pthread_ptr:h,parent_pthread_ptr:zn(),arg:r,transferList:a};return y?(v.cmd="spawnThread",postMessage(v,a)):Hn(v),0}function qn(e){return(e=+e)>=0?+he(e+.5):+me(e-.5)}function Vn(e){if(y)return un(6,1,e);switch(e){case 30:return 16384;case 85:return 131072;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:case 79:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator&&navigator.hardwareConcurrency||1}return Ye(28),-1}p._pthread_self=zn,y?qe.initWorker():qe.initMainThreadBlock(),Nn.init();var Gn=[null,Qe,kn,Dn,Pn,Wn,Vn],Kn={e:Ke,r:Xe,w:Ze,a:Je,l:$e,d:en,c:Le,h:je,g:nn,x:tn,q:rn,B:an,t:ln,A:pn,u:In,k:Sn,s:En,v:On,m:Dn,o:Pn,i:Wn,p:Oe,memory:x||p.wasmMemory,y:Bn,z:Ln,j:jn,b:zn,f:qn,n:Vn,table:O},Xn=Fe();p.asm=Xn;var Yn,Qn=p.___wasm_call_ctors=function(){return(Qn=p.___wasm_call_ctors=p.asm.C).apply(null,arguments)},Zn=(p._init=function(){return(p._init=p.asm.D).apply(null,arguments)},p._register_tensor=function(){return(p._register_tensor=p.asm.E).apply(null,arguments)},p._dispose_data=function(){return(p._dispose_data=p.asm.F).apply(null,arguments)},p._dispose=function(){return(p._dispose=p.asm.G).apply(null,arguments)},p._Abs=function(){return(p._Abs=p.asm.H).apply(null,arguments)},p._Add=function(){return(p._Add=p.asm.I).apply(null,arguments)},p._AddN=function(){return(p._AddN=p.asm.J).apply(null,arguments)},p._ArgMax=function(){return(p._ArgMax=p.asm.K).apply(null,arguments)},p._AvgPool=function(){return(p._AvgPool=p.asm.L).apply(null,arguments)},p._BatchMatMul=function(){return(p._BatchMatMul=p.asm.M).apply(null,arguments)},p._ClipByValue=function(){return(p._ClipByValue=p.asm.N).apply(null,arguments)},p._Conv2D=function(){return(p._Conv2D=p.asm.O).apply(null,arguments)},p._Conv2DBackpropInput=function(){return(p._Conv2DBackpropInput=p.asm.P).apply(null,arguments)},p._Cos=function(){return(p._Cos=p.asm.Q).apply(null,arguments)},p._CropAndResize=function(){return(p._CropAndResize=p.asm.R).apply(null,arguments)},p._Cumsum=function(){return(p._Cumsum=p.asm.S).apply(null,arguments)},p._DepthToSpace=function(){return(p._DepthToSpace=p.asm.T).apply(null,arguments)},p._DepthwiseConv2dNative=function(){return(p._DepthwiseConv2dNative=p.asm.U).apply(null,arguments)},p._Equal=function(){return(p._Equal=p.asm.V).apply(null,arguments)},p._Exp=function(){return(p._Exp=p.asm.W).apply(null,arguments)},p._FlipLeftRight=function(){return(p._FlipLeftRight=p.asm.X).apply(null,arguments)},p._Floor=function(){return(p._Floor=p.asm.Y).apply(null,arguments)},p._FloorDiv=function(){return(p._FloorDiv=p.asm.Z).apply(null,arguments)},p._FusedBatchNorm=function(){return(p._FusedBatchNorm=p.asm._).apply(null,arguments)},p._FusedConv2D=function(){return(p._FusedConv2D=p.asm.$).apply(null,arguments)},p._FusedDepthwiseConv2D=function(){return(p._FusedDepthwiseConv2D=p.asm.aa).apply(null,arguments)},p._Gather=function(){return(p._Gather=p.asm.ba).apply(null,arguments)},p._GatherNd=function(){return(p._GatherNd=p.asm.ca).apply(null,arguments)},p._Greater=function(){return(p._Greater=p.asm.da).apply(null,arguments)},p._GreaterEqual=function(){return(p._GreaterEqual=p.asm.ea).apply(null,arguments)},p._LeakyRelu=function(){return(p._LeakyRelu=p.asm.fa).apply(null,arguments)},p._Less=function(){return(p._Less=p.asm.ga).apply(null,arguments)},p._LessEqual=function(){return(p._LessEqual=p.asm.ha).apply(null,arguments)},p._Log=function(){return(p._Log=p.asm.ia).apply(null,arguments)},p._LogicalAnd=function(){return(p._LogicalAnd=p.asm.ja).apply(null,arguments)},p._Max=function(){return(p._Max=p.asm.ka).apply(null,arguments)},p._MaxPool=function(){return(p._MaxPool=p.asm.la).apply(null,arguments)},p._Maximum=function(){return(p._Maximum=p.asm.ma).apply(null,arguments)},p._Mean=function(){return(p._Mean=p.asm.na).apply(null,arguments)},p._Min=function(){return(p._Min=p.asm.oa).apply(null,arguments)},p._Minimum=function(){return(p._Minimum=p.asm.pa).apply(null,arguments)},p._Multiply=function(){return(p._Multiply=p.asm.qa).apply(null,arguments)},p._Neg=function(){return(p._Neg=p.asm.ra).apply(null,arguments)},p._NonMaxSuppressionV3=function(){return(p._NonMaxSuppressionV3=p.asm.sa).apply(null,arguments)},p._NonMaxSuppressionV4=function(){return(p._NonMaxSuppressionV4=p.asm.ta).apply(null,arguments)},p._NonMaxSuppressionV5=function(){return(p._NonMaxSuppressionV5=p.asm.ua).apply(null,arguments)},p._NotEqual=function(){return(p._NotEqual=p.asm.va).apply(null,arguments)},p._OneHot=function(){return(p._OneHot=p.asm.wa).apply(null,arguments)},p._PadV2=function(){return(p._PadV2=p.asm.xa).apply(null,arguments)},p._Pow=function(){return(p._Pow=p.asm.ya).apply(null,arguments)},p._Prelu=function(){return(p._Prelu=p.asm.za).apply(null,arguments)},p._Prod=function(){return(p._Prod=p.asm.Aa).apply(null,arguments)},p._RealDiv=function(){return(p._RealDiv=p.asm.Ba).apply(null,arguments)},p._Relu=function(){return(p._Relu=p.asm.Ca).apply(null,arguments)},p._Relu6=function(){return(p._Relu6=p.asm.Da).apply(null,arguments)},p._ResizeBilinear=function(){return(p._ResizeBilinear=p.asm.Ea).apply(null,arguments)},p._Reverse=function(){return(p._Reverse=p.asm.Fa).apply(null,arguments)},p._RotateWithOffset=function(){return(p._RotateWithOffset=p.asm.Ga).apply(null,arguments)},p._Round=function(){return(p._Round=p.asm.Ha).apply(null,arguments)},p._Rsqrt=function(){return(p._Rsqrt=p.asm.Ia).apply(null,arguments)},p._ScatterNd=function(){return(p._ScatterNd=p.asm.Ja).apply(null,arguments)},p._SelectV2=function(){return(p._SelectV2=p.asm.Ka).apply(null,arguments)},p._Sigmoid=function(){return(p._Sigmoid=p.asm.La).apply(null,arguments)},p._Sin=function(){return(p._Sin=p.asm.Ma).apply(null,arguments)},p._Softmax=function(){return(p._Softmax=p.asm.Na).apply(null,arguments)},p._Sqrt=function(){return(p._Sqrt=p.asm.Oa).apply(null,arguments)},p._Square=function(){return(p._Square=p.asm.Pa).apply(null,arguments)},p._SquaredDifference=function(){return(p._SquaredDifference=p.asm.Qa).apply(null,arguments)},p._Step=function(){return(p._Step=p.asm.Ra).apply(null,arguments)},p._StridedSlice=function(){return(p._StridedSlice=p.asm.Sa).apply(null,arguments)},p._Sub=function(){return(p._Sub=p.asm.Ta).apply(null,arguments)},p._Sum=function(){return(p._Sum=p.asm.Ua).apply(null,arguments)},p._Tanh=function(){return(p._Tanh=p.asm.Va).apply(null,arguments)},p._Tile=function(){return(p._Tile=p.asm.Wa).apply(null,arguments)},p._TopK=function(){return(p._TopK=p.asm.Xa).apply(null,arguments)},p._Transpose=function(){return(p._Transpose=p.asm.Ya).apply(null,arguments)},p.__FusedMatMul=function(){return(p.__FusedMatMul=p.asm.Za).apply(null,arguments)},p._malloc=function(){return(Zn=p._malloc=p.asm._a).apply(null,arguments)}),Jn=p._free=function(){return(Jn=p._free=p.asm.$a).apply(null,arguments)},$n=p.___errno_location=function(){return($n=p.___errno_location=p.asm.ab).apply(null,arguments)},et=p._emscripten_get_global_libc=function(){return(et=p._emscripten_get_global_libc=p.asm.bb).apply(null,arguments)},nt=(p.___em_js__initPthreadsJS=function(){return(p.___em_js__initPthreadsJS=p.asm.cb).apply(null,arguments)},p._memalign=function(){return(nt=p._memalign=p.asm.db).apply(null,arguments)}),tt=p.___pthread_tsd_run_dtors=function(){return(tt=p.___pthread_tsd_run_dtors=p.asm.eb).apply(null,arguments)},rt=p._emscripten_main_thread_process_queued_calls=function(){return(rt=p._emscripten_main_thread_process_queued_calls=p.asm.fb).apply(null,arguments)},at=(p._emscripten_current_thread_process_queued_calls=function(){return(p._emscripten_current_thread_process_queued_calls=p.asm.gb).apply(null,arguments)},p._emscripten_register_main_browser_thread_id=function(){return(at=p._emscripten_register_main_browser_thread_id=p.asm.hb).apply(null,arguments)}),ut=(p._emscripten_main_browser_thread_id=function(){return(p._emscripten_main_browser_thread_id=p.asm.ib).apply(null,arguments)},p._emscripten_async_run_in_main_thread=function(){return(p._emscripten_async_run_in_main_thread=p.asm.jb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread=function(){return(p._emscripten_sync_run_in_main_thread=p.asm.kb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_0=function(){return(p._emscripten_sync_run_in_main_thread_0=p.asm.lb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_1=function(){return(p._emscripten_sync_run_in_main_thread_1=p.asm.mb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_2=function(){return(p._emscripten_sync_run_in_main_thread_2=p.asm.nb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_xprintf_varargs=function(){return(p._emscripten_sync_run_in_main_thread_xprintf_varargs=p.asm.ob).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_3=function(){return(p._emscripten_sync_run_in_main_thread_3=p.asm.pb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_4=function(){return(ut=p._emscripten_sync_run_in_main_thread_4=p.asm.qb).apply(null,arguments)}),it=(p._emscripten_sync_run_in_main_thread_5=function(){return(p._emscripten_sync_run_in_main_thread_5=p.asm.rb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_6=function(){return(p._emscripten_sync_run_in_main_thread_6=p.asm.sb).apply(null,arguments)},p._emscripten_sync_run_in_main_thread_7=function(){return(p._emscripten_sync_run_in_main_thread_7=p.asm.tb).apply(null,arguments)},p._emscripten_run_in_main_runtime_thread_js=function(){return(it=p._emscripten_run_in_main_runtime_thread_js=p.asm.ub).apply(null,arguments)}),st=p._emscripten_async_queue_on_thread_=function(){return(st=p._emscripten_async_queue_on_thread_=p.asm.vb).apply(null,arguments)},ot=(p._emscripten_tls_init=function(){return(p._emscripten_tls_init=p.asm.wb).apply(null,arguments)},p.stackSave=function(){return(ot=p.stackSave=p.asm.xb).apply(null,arguments)}),lt=p.stackAlloc=function(){return(lt=p.stackAlloc=p.asm.yb).apply(null,arguments)},dt=p.stackRestore=function(){return(dt=p.stackRestore=p.asm.zb).apply(null,arguments)},ct=p.dynCall_vi=function(){return(ct=p.dynCall_vi=p.asm.Ab).apply(null,arguments)};function pt(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function ft(e){function n(){Yn||(Yn=!0,p.calledRun=!0,R||(le(),de(),p.onRuntimeInitialized&&p.onRuntimeInitialized(),ce()))}be>0||(oe(),be>0||(p.setStatus?(p.setStatus("Running..."),setTimeout((function(){setTimeout((function(){p.setStatus("")}),1),n()}),1)):n()))}if(p.dynCall_v=function(){return(p.dynCall_v=p.asm.Bb).apply(null,arguments)},p.dynCall_ii=function(){return(p.dynCall_ii=p.asm.Cb).apply(null,arguments)},p.asm=Xn,p.cwrap=B,p.PThread=qe,p.PThread=qe,p._pthread_self=zn,p.wasmMemory=x,p.ExitStatus=pt,p.then=function(e){if(Yn)e(p);else{var n=p.onRuntimeInitialized;p.onRuntimeInitialized=function(){n&&n(),e(p)}}return p},ye=function e(){Yn||ft(),Yn||(ye=e)},p.run=ft,p.preInit)for("function"==typeof p.preInit&&(p.preInit=[p.preInit]);p.preInit.length>0;)p.preInit.pop()();return y||(M=!0),y||ft(),e});e.exports=s}));var On=Fn((function(e,n){var a,u=(a="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,"undefined"!=typeof __filename&&(a=a||__filename),function(e){var n,u="undefined"!=typeof(e=e||{})?e:{},i={};for(n in u)u.hasOwnProperty(n)&&(i[n]=u[n]);var s=function(e,n){throw n},o=!1,l=!1,d=!1,c=!1;o="object"==typeof window,l="function"==typeof importScripts,d="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node,c=!o&&!d&&!l;var p,f,m,h,b="";function _(e){return u.locateFile?u.locateFile(e,b):b+e}d?(b=l?t.dirname(b)+"/":__dirname+"/",p=function(e,n){return m||(m=r),h||(h=t),e=h.normalize(e),m.readFileSync(e,n?null:"utf8")},f=function(e){var n=p(e,!0);return n.buffer||(n=new Uint8Array(n)),S(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Ae))throw e})),process.on("unhandledRejection",te),s=function(e){process.exit(e)},u.inspect=function(){return"[Emscripten Module object]"}):c?("undefined"!=typeof read&&(p=function(e){return read(e)}),f=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(S("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"function"==typeof quit&&(s=function(e){quit(e)}),"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(o||l)&&(l?b=self.location.href:document.currentScript&&(b=document.currentScript.src),a&&(b=a),b=0!==b.indexOf("blob:")?b.substr(0,b.lastIndexOf("/")+1):"",p=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},l&&(f=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}));var y,v,g,w=u.print||console.log.bind(console),k=u.printErr||console.warn.bind(console);for(n in i)i.hasOwnProperty(n)&&(u[n]=i[n]);i=null,u.arguments&&u.arguments,u.thisProgram&&u.thisProgram,u.quit&&(s=u.quit),u.wasmBinary&&(y=u.wasmBinary),u.noExitRuntime&&(v=u.noExitRuntime),"object"!=typeof WebAssembly&&k("no native wasm support detected"),new WebAssembly.Table({initial:151,maximum:151,element:"anyfunc"});var I=!1;function S(e,n){e||te("Assertion failed: "+n)}function E(e){var n=u["_"+e];return S(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function A(e,n,t,r,a){var u={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);D(e,n=Se(t),t)}return n},array:function(e){var n=Se(e.length);return P(e,n),n}},i=E(e),s=[],o=0;if(r)for(var l=0;l<r.length;l++){var d=u[t[l]];d?(0===o&&(o=Ie()),s[l]=d(r[l])):s[l]=r[l]}var c=i.apply(null,s);return c=function(e){return"string"===n?C(e):"boolean"===n?Boolean(e):e}(c),0!==o&&Ee(o),c}function M(e,n,t,r){var a=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&a&&!r?E(e):function(){return A(e,n,t,arguments)}}var x,N,F,T="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function O(e,n,t){for(var r=n+t,a=n;e[a]&&!(a>=r);)++a;if(a-n>16&&e.subarray&&T)return T.decode(e.subarray(n,a));for(var u="";n<a;){var i=e[n++];if(128&i){var s=63&e[n++];if(192!=(224&i)){var o=63&e[n++];if((i=224==(240&i)?(15&i)<<12|s<<6|o:(7&i)<<18|s<<12|o<<6|63&e[n++])<65536)u+=String.fromCharCode(i);else{var l=i-65536;u+=String.fromCharCode(55296|l>>10,56320|1023&l)}}else u+=String.fromCharCode((31&i)<<6|s)}else u+=String.fromCharCode(i)}return u}function C(e,n){return e?O(N,e,n):""}function R(e,n,t,r){if(!(r>0))return 0;for(var a=t,u=t+r-1,i=0;i<e.length;++i){var s=e.charCodeAt(i);if(s>=55296&&s<=57343&&(s=65536+((1023&s)<<10)|1023&e.charCodeAt(++i)),s<=127){if(t>=u)break;n[t++]=s}else if(s<=2047){if(t+1>=u)break;n[t++]=192|s>>6,n[t++]=128|63&s}else if(s<=65535){if(t+2>=u)break;n[t++]=224|s>>12,n[t++]=128|s>>6&63,n[t++]=128|63&s}else{if(t+3>=u)break;n[t++]=240|s>>18,n[t++]=128|s>>12&63,n[t++]=128|s>>6&63,n[t++]=128|63&s}}return n[t]=0,t-a}function D(e,n,t){return R(e,N,n,t)}function P(e,n){x.set(e,n)}function W(e){u.HEAP8=x=new Int8Array(e),u.HEAP16=new Int16Array(e),u.HEAP32=F=new Int32Array(e),u.HEAPU8=N=new Uint8Array(e),u.HEAPU16=new Uint16Array(e),u.HEAPU32=new Uint32Array(e),u.HEAPF32=new Float32Array(e),u.HEAPF64=new Float64Array(e)}function B(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?u.dynCall_v(t):u.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n(u)}}u.INITIAL_MEMORY;var L=[],H=[],U=[],z=[];function j(){if(u.preRun)for("function"==typeof u.preRun&&(u.preRun=[u.preRun]);u.preRun.length;)K(u.preRun.shift());B(L)}function q(){B(H)}function V(){B(U)}function G(){if(u.postRun)for("function"==typeof u.postRun&&(u.postRun=[u.postRun]);u.postRun.length;)X(u.postRun.shift());B(z)}function K(e){L.unshift(e)}function X(e){z.unshift(e)}var Y=Math.ceil,Q=Math.floor,Z=0,J=null,$=null;function ee(e){Z++,u.monitorRunDependencies&&u.monitorRunDependencies(Z)}function ne(e){if(Z--,u.monitorRunDependencies&&u.monitorRunDependencies(Z),0==Z&&(null!==J&&(clearInterval(J),J=null),$)){var n=$;$=null,n()}}function te(e){throw u.onAbort&&u.onAbort(e),w(e+=""),k(e),I=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}function re(e,n){return String.prototype.startsWith?e.startsWith(n):0===e.indexOf(n)}u.preloadedImages={},u.preloadedAudios={};var ae="data:application/octet-stream;base64,";function ue(e){return re(e,ae)}var ie="file://";function se(e){return re(e,ie)}var oe="tfjs-backend-wasm.wasm";function le(){try{if(y)return new Uint8Array(y);if(f)return f(oe);throw"both async and sync fetching of the wasm failed"}catch(e){te(e)}}function de(){return y||!o&&!l||"function"!=typeof fetch||se(oe)?new Promise((function(e,n){e(le())})):fetch(oe,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+oe+"'";return e.arrayBuffer()})).catch((function(){return le()}))}function ce(){var e={env:ge,wasi_snapshot_preview1:ge};function n(e,n){var t=e.exports;u.asm=t,W((g=t.memory).buffer),ne()}function t(e){n(e.instance)}function r(n){return de().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){k("failed to asynchronously prepare wasm: "+e),te(e)}))}if(ee(),u.instantiateWasm)try{return u.instantiateWasm(e,n)}catch(e){return k("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(y||"function"!=typeof WebAssembly.instantiateStreaming||ue(oe)||se(oe)||"function"!=typeof fetch)return r(t);fetch(oe,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){k("wasm streaming compile failed: "+e),k("falling back to ArrayBuffer instantiation"),r(t)}))}))}(),{}}function pe(e){W(g.buffer)}ue(oe)||(oe=_(oe)),H.push();var fe={mappings:{},buffers:[null,[],[]],printChar:function(e,n){var t=fe.buffers[e];0===n||10===n?((1===e?w:k)(O(t,0)),t.length=0):t.push(n)},varargs:void 0,get:function(){return fe.varargs+=4,F[fe.varargs-4>>2]},getStr:function(e){return C(e)},get64:function(e,n){return e}};function me(e){return 0}function he(e,n,t,r,a){}function be(e,n,t,r){for(var a=0,u=0;u<t;u++){for(var i=F[n+8*u>>2],s=F[n+(8*u+4)>>2],o=0;o<s;o++)fe.printChar(e,N[i+o]);a+=s}return F[r>>2]=a,0}function _e(e){Ne(e)}function ye(e){_e(e)}function ve(e){return(e=+e)>=0?+Q(e+.5):+Y(e-.5)}var ge={emscripten_notify_memory_growth:pe,fd_close:me,fd_seek:he,fd_write:be,proc_exit:ye,roundf:ve},we=ce();u.asm=we,u._init=function(){return(u._init=u.asm.init).apply(null,arguments)},u._register_tensor=function(){return(u._register_tensor=u.asm.register_tensor).apply(null,arguments)},u._dispose_data=function(){return(u._dispose_data=u.asm.dispose_data).apply(null,arguments)},u._dispose=function(){return(u._dispose=u.asm.dispose).apply(null,arguments)},u._Abs=function(){return(u._Abs=u.asm.Abs).apply(null,arguments)},u._Add=function(){return(u._Add=u.asm.Add).apply(null,arguments)},u._AddN=function(){return(u._AddN=u.asm.AddN).apply(null,arguments)},u._ArgMax=function(){return(u._ArgMax=u.asm.ArgMax).apply(null,arguments)},u._AvgPool=function(){return(u._AvgPool=u.asm.AvgPool).apply(null,arguments)},u._BatchMatMul=function(){return(u._BatchMatMul=u.asm.BatchMatMul).apply(null,arguments)},u._ClipByValue=function(){return(u._ClipByValue=u.asm.ClipByValue).apply(null,arguments)},u._Conv2D=function(){return(u._Conv2D=u.asm.Conv2D).apply(null,arguments)},u._Conv2DBackpropInput=function(){return(u._Conv2DBackpropInput=u.asm.Conv2DBackpropInput).apply(null,arguments)},u._Cos=function(){return(u._Cos=u.asm.Cos).apply(null,arguments)},u._CropAndResize=function(){return(u._CropAndResize=u.asm.CropAndResize).apply(null,arguments)},u._Cumsum=function(){return(u._Cumsum=u.asm.Cumsum).apply(null,arguments)},u._DepthToSpace=function(){return(u._DepthToSpace=u.asm.DepthToSpace).apply(null,arguments)},u._DepthwiseConv2dNative=function(){return(u._DepthwiseConv2dNative=u.asm.DepthwiseConv2dNative).apply(null,arguments)},u._Equal=function(){return(u._Equal=u.asm.Equal).apply(null,arguments)},u._Exp=function(){return(u._Exp=u.asm.Exp).apply(null,arguments)},u._FlipLeftRight=function(){return(u._FlipLeftRight=u.asm.FlipLeftRight).apply(null,arguments)},u._Floor=function(){return(u._Floor=u.asm.Floor).apply(null,arguments)},u._FloorDiv=function(){return(u._FloorDiv=u.asm.FloorDiv).apply(null,arguments)},u._FusedBatchNorm=function(){return(u._FusedBatchNorm=u.asm.FusedBatchNorm).apply(null,arguments)},u._FusedConv2D=function(){return(u._FusedConv2D=u.asm.FusedConv2D).apply(null,arguments)},u._FusedDepthwiseConv2D=function(){return(u._FusedDepthwiseConv2D=u.asm.FusedDepthwiseConv2D).apply(null,arguments)},u._Gather=function(){return(u._Gather=u.asm.Gather).apply(null,arguments)},u._GatherNd=function(){return(u._GatherNd=u.asm.GatherNd).apply(null,arguments)},u._Greater=function(){return(u._Greater=u.asm.Greater).apply(null,arguments)},u._GreaterEqual=function(){return(u._GreaterEqual=u.asm.GreaterEqual).apply(null,arguments)},u._LeakyRelu=function(){return(u._LeakyRelu=u.asm.LeakyRelu).apply(null,arguments)},u._Less=function(){return(u._Less=u.asm.Less).apply(null,arguments)},u._LessEqual=function(){return(u._LessEqual=u.asm.LessEqual).apply(null,arguments)},u._Log=function(){return(u._Log=u.asm.Log).apply(null,arguments)},u._LogicalAnd=function(){return(u._LogicalAnd=u.asm.LogicalAnd).apply(null,arguments)},u._Max=function(){return(u._Max=u.asm.Max).apply(null,arguments)},u._MaxPool=function(){return(u._MaxPool=u.asm.MaxPool).apply(null,arguments)},u._Maximum=function(){return(u._Maximum=u.asm.Maximum).apply(null,arguments)},u._Mean=function(){return(u._Mean=u.asm.Mean).apply(null,arguments)},u._Min=function(){return(u._Min=u.asm.Min).apply(null,arguments)},u._Minimum=function(){return(u._Minimum=u.asm.Minimum).apply(null,arguments)},u._Multiply=function(){return(u._Multiply=u.asm.Multiply).apply(null,arguments)},u._Neg=function(){return(u._Neg=u.asm.Neg).apply(null,arguments)},u._NonMaxSuppressionV3=function(){return(u._NonMaxSuppressionV3=u.asm.NonMaxSuppressionV3).apply(null,arguments)},u._NonMaxSuppressionV4=function(){return(u._NonMaxSuppressionV4=u.asm.NonMaxSuppressionV4).apply(null,arguments)},u._NonMaxSuppressionV5=function(){return(u._NonMaxSuppressionV5=u.asm.NonMaxSuppressionV5).apply(null,arguments)},u._NotEqual=function(){return(u._NotEqual=u.asm.NotEqual).apply(null,arguments)},u._OneHot=function(){return(u._OneHot=u.asm.OneHot).apply(null,arguments)},u._PadV2=function(){return(u._PadV2=u.asm.PadV2).apply(null,arguments)},u._Pow=function(){return(u._Pow=u.asm.Pow).apply(null,arguments)},u._Prelu=function(){return(u._Prelu=u.asm.Prelu).apply(null,arguments)},u._Prod=function(){return(u._Prod=u.asm.Prod).apply(null,arguments)},u._RealDiv=function(){return(u._RealDiv=u.asm.RealDiv).apply(null,arguments)},u._Relu=function(){return(u._Relu=u.asm.Relu).apply(null,arguments)},u._Relu6=function(){return(u._Relu6=u.asm.Relu6).apply(null,arguments)},u._ResizeBilinear=function(){return(u._ResizeBilinear=u.asm.ResizeBilinear).apply(null,arguments)},u._Reverse=function(){return(u._Reverse=u.asm.Reverse).apply(null,arguments)},u._RotateWithOffset=function(){return(u._RotateWithOffset=u.asm.RotateWithOffset).apply(null,arguments)},u._Round=function(){return(u._Round=u.asm.Round).apply(null,arguments)},u._Rsqrt=function(){return(u._Rsqrt=u.asm.Rsqrt).apply(null,arguments)},u._ScatterNd=function(){return(u._ScatterNd=u.asm.ScatterNd).apply(null,arguments)},u._SelectV2=function(){return(u._SelectV2=u.asm.SelectV2).apply(null,arguments)},u._Sigmoid=function(){return(u._Sigmoid=u.asm.Sigmoid).apply(null,arguments)},u._Sin=function(){return(u._Sin=u.asm.Sin).apply(null,arguments)},u._Softmax=function(){return(u._Softmax=u.asm.Softmax).apply(null,arguments)},u._Sqrt=function(){return(u._Sqrt=u.asm.Sqrt).apply(null,arguments)},u._Square=function(){return(u._Square=u.asm.Square).apply(null,arguments)},u._SquaredDifference=function(){return(u._SquaredDifference=u.asm.SquaredDifference).apply(null,arguments)},u._Step=function(){return(u._Step=u.asm.Step).apply(null,arguments)},u._StridedSlice=function(){return(u._StridedSlice=u.asm.StridedSlice).apply(null,arguments)},u._Sub=function(){return(u._Sub=u.asm.Sub).apply(null,arguments)},u._Sum=function(){return(u._Sum=u.asm.Sum).apply(null,arguments)},u._Tanh=function(){return(u._Tanh=u.asm.Tanh).apply(null,arguments)},u._Tile=function(){return(u._Tile=u.asm.Tile).apply(null,arguments)},u._TopK=function(){return(u._TopK=u.asm.TopK).apply(null,arguments)},u._Transpose=function(){return(u._Transpose=u.asm.Transpose).apply(null,arguments)},u.__FusedMatMul=function(){return(u.__FusedMatMul=u.asm._FusedMatMul).apply(null,arguments)},u._malloc=function(){return(u._malloc=u.asm.malloc).apply(null,arguments)},u._free=function(){return(u._free=u.asm.free).apply(null,arguments)},u.__start=function(){return(u.__start=u.asm._start).apply(null,arguments)};var ke,Ie=u.stackSave=function(){return(Ie=u.stackSave=u.asm.stackSave).apply(null,arguments)},Se=u.stackAlloc=function(){return(Se=u.stackAlloc=u.asm.stackAlloc).apply(null,arguments)},Ee=u.stackRestore=function(){return(Ee=u.stackRestore=u.asm.stackRestore).apply(null,arguments)};function Ae(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function Me(e){var n=u.__start;try{n(),Ne(0,!0)}catch(e){if(e instanceof Ae)return;if("unwind"==e)return void(v=!0);var t=e;e&&"object"==typeof e&&e.stack&&(t=[e,e.stack]),k("exception thrown: "+t),s(1,e)}}function xe(e){function n(){ke||(ke=!0,u.calledRun=!0,I||(q(),V(),u.onRuntimeInitialized&&u.onRuntimeInitialized(),Fe&&Me(),G()))}Z>0||(j(),Z>0||(u.setStatus?(u.setStatus("Running..."),setTimeout((function(){setTimeout((function(){u.setStatus("")}),1),n()}),1)):n()))}function Ne(e,n){n&&v&&0===e||(v||(I=!0,u.onExit&&u.onExit(e)),s(e,new Ae(e)))}if(u.asm=we,u.cwrap=M,u.then=function(e){if(ke)e(u);else{var n=u.onRuntimeInitialized;u.onRuntimeInitialized=function(){n&&n(),e(u)}}return u},$=function e(){ke||xe(),ke||($=e)},u.run=xe,u.preInit)for("function"==typeof u.preInit&&(u.preInit=[u.preInit]);u.preInit.length>0;)u.preInit.pop()();var Fe=!0;return u.noInitialRun&&(Fe=!1),v=!0,xe(),e});e.exports=u})),Cn=function(e){function t(t){var r=e.call(this)||this;return r.wasm=t,r.dataIdNextNumber=1,r.wasm.tfjs.init(),r.dataIdMap=new n.DataStorage(r,n.engine()),r}return function(e,n){function t(){this.constructor=e}An(e,n),e.prototype=null===n?Object.create(n):(t.prototype=n.prototype,new t)}(t,e),t.prototype.write=function(e,n,t){var r={};return this.move(r,e,n,t),r},t.prototype.numDataIds=function(){return this.dataIdMap.numDataIds()},t.prototype.time=function(e){return Mn(this,void 0,void 0,(function(){var t;return xn(this,(function(r){return t=n.util.now(),e(),[2,{kernelMs:n.util.now()-t}]}))}))},t.prototype.move=function(e,t,r,a){var u=this.dataIdNextNumber++;if("string"!==a){var i=n.util.sizeFromShape(r),s=i*n.util.bytesPerElement(a),o=this.wasm._malloc(s);this.dataIdMap.set(e,{id:u,memoryOffset:o,shape:r,dtype:a}),this.wasm.tfjs.registerTensor(u,i,o),null!=t&&this.wasm.HEAPU8.set(new Uint8Array(t.buffer,t.byteOffset,s),o)}else{var l=t;this.dataIdMap.set(e,{id:u,stringBytes:l,shape:r,dtype:a,memoryOffset:null})}},t.prototype.read=function(e){return Mn(this,void 0,void 0,(function(){return xn(this,(function(n){return[2,this.readSync(e)]}))}))},t.prototype.readSync=function(e){var t=this.dataIdMap.get(e),r=t.memoryOffset,a=t.dtype,u=t.shape,i=t.stringBytes;return"string"===a?i:function(e,n){switch(n){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error("Unknown dtype "+n)}}(this.wasm.HEAPU8.slice(r,r+n.util.sizeFromShape(u)*n.util.bytesPerElement(a)).buffer,a)},t.prototype.disposeData=function(e){var n=this.dataIdMap.get(e);this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)},t.prototype.floatPrecision=function(){return 32},t.prototype.getMemoryOffset=function(e){return this.dataIdMap.get(e).memoryOffset},t.prototype.dispose=function(){this.wasm.tfjs.dispose(),this.wasm=null},t.prototype.memory=function(){return{unreliable:!1}},t.prototype.makeOutput=function(e,t,r){var a;if(null==r)a=this.write(null,e,t);else{a={};var u=this.dataIdNextNumber++;this.dataIdMap.set(a,{id:u,memoryOffset:r,shape:e,dtype:t});var i=n.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(u,i,r)}return{dataId:a,shape:e,dtype:t}},t.prototype.typedArrayFromHeap=function(e){var t=e.shape,r=e.dtype,a=e.dataId,u=this.wasm.HEAPU8.buffer,i=this.dataIdMap.get(a).memoryOffset,s=n.util.sizeFromShape(t);switch(r){case"float32":return new Float32Array(u,i,s);case"int32":return new Int32Array(u,i,s);case"bool":return new Uint8Array(u,i,s);default:throw new Error("Unknown dtype "+r)}},t}(n.KernelBackend);function Rn(e,n,t){if(null!=Wn)return Wn;var r="tfjs-backend-wasm.wasm";return e&&n?r="tfjs-backend-wasm-threaded-simd.wasm":e&&(r="tfjs-backend-wasm-simd.wasm"),null!=Ln&&null!=Ln[r]?Ln[r]:t+r}function Dn(){return Mn(this,void 0,void 0,(function(){var e,t,r;return xn(this,(function(a){switch(a.label){case 0:return[4,Promise.all([n.env().getAsync("WASM_HAS_SIMD_SUPPORT"),n.env().getAsync("WASM_HAS_MULTITHREAD_SUPPORT")])];case 1:return e=a.sent(),t=e[0],r=e[1],[2,new Promise((function(e,a){var u,i={};i.locateFile=function(e,n){if(e.endsWith(".worker.js")){var a=new Blob(['var threadInfoStruct=0;var selfThreadId=0;var parentThreadId=0;var Module={};function threadPrintErr(){var text=Array.prototype.slice.call(arguments).join(" ");console.error(text)}function threadAlert(){var text=Array.prototype.slice.call(arguments).join(" ");postMessage({cmd:"alert",text:text,threadId:selfThreadId})}var err=threadPrintErr;this.alert=threadAlert;Module["instantiateWasm"]=function(info,receiveInstance){var instance=new WebAssembly.Instance(Module["wasmModule"],info);Module["wasmModule"]=null;receiveInstance(instance);return instance.exports};this.onmessage=function(e){try{if(e.data.cmd==="load"){Module["DYNAMIC_BASE"]=e.data.DYNAMIC_BASE;Module["DYNAMICTOP_PTR"]=e.data.DYNAMICTOP_PTR;Module["wasmModule"]=e.data.wasmModule;Module["wasmMemory"]=e.data.wasmMemory;Module["buffer"]=Module["wasmMemory"].buffer;Module["ENVIRONMENT_IS_PTHREAD"]=true;if(typeof e.data.urlOrBlob==="string"){importScripts(e.data.urlOrBlob)}else{var objectUrl=URL.createObjectURL(e.data.urlOrBlob);importScripts(objectUrl);URL.revokeObjectURL(objectUrl)}Module=WasmBackendModuleThreadedSimd(Module);postMessage({"cmd":"loaded"})}else if(e.data.cmd==="objectTransfer"){Module["PThread"].receiveObjectTransfer(e.data)}else if(e.data.cmd==="run"){Module["__performance_now_clock_drift"]=performance.now()-e.data.time;threadInfoStruct=e.data.threadInfoStruct;Module["__register_pthread_ptr"](threadInfoStruct,0,0);selfThreadId=e.data.selfThreadId;parentThreadId=e.data.parentThreadId;var max=e.data.stackBase;var top=e.data.stackBase+e.data.stackSize;Module["establishStackSpace"](top,max);Module["_emscripten_tls_init"]();Module["PThread"].receiveObjectTransfer(e.data);Module["PThread"].setThreadStatus(Module["_pthread_self"](),1);try{var result=Module["dynCall_ii"](e.data.start_routine,e.data.arg);if(!Module["getNoExitRuntime"]())Module["PThread"].threadExit(result)}catch(ex){if(ex==="Canceled!"){Module["PThread"].threadCancel()}else if(ex!="unwind"){Atomics.store(Module["HEAPU32"],threadInfoStruct+4>>2,ex instanceof Module["ExitStatus"]?ex.status:-2);Atomics.store(Module["HEAPU32"],threadInfoStruct+0>>2,1);Module["_emscripten_futex_wake"](threadInfoStruct+0,2147483647);if(!(ex instanceof Module["ExitStatus"]))throw ex}}}else if(e.data.cmd==="cancel"){if(threadInfoStruct){Module["PThread"].threadCancel()}}else if(e.data.target==="setimmediate"){}else if(e.data.cmd==="processThreadQueue"){if(threadInfoStruct){Module["_emscripten_current_thread_process_queued_calls"]()}}else{err("worker.js received unknown command "+e.data.cmd);err(e.data)}}catch(ex){err("worker.js onmessage() captured an uncaught exception: "+ex);if(ex.stack)err(ex.stack);throw ex}};if(typeof process==="object"&&typeof process.versions==="object"&&typeof process.versions.node==="string"){self={location:{href:__filename}};var onmessage=this.onmessage;var nodeWorkerThreads=require("worker_threads");Worker=nodeWorkerThreads.Worker;var parentPort=nodeWorkerThreads.parentPort;parentPort.on("message",function(data){onmessage({data:data})});var nodeFS=require("fs");var nodeRead=function(filename){return nodeFS.readFileSync(filename,"utf8")};function globalEval(x){global.require=require;global.Module=Module;eval.call(null,x)}importScripts=function(f){globalEval(nodeRead(f))};postMessage=function(msg){parentPort.postMessage(msg)};if(typeof performance==="undefined"){performance={now:function(){return Date.now()}}}}'],{type:"application/javascript"});return URL.createObjectURL(a)}return e.endsWith(".wasm")?Rn(t,r,null!=Bn?Bn:n):n+e},Un&&(i.instantiateWasm=function(e){return function(t,r){return n.util.fetch(e,{credentials:"same-origin"}).then((function(n){n.ok||t.env.a("failed to load wasm binary file at '"+e+"'"),n.arrayBuffer().then((function(e){WebAssembly.instantiate(e,t).then((function(e){r(e.instance)}))}))})),{}}}(Rn(t,r,null!=Bn?Bn:""))),r&&t&&null==Wn?(u=Tn(i)).mainScriptUrlOrBlob=new Blob(["var WasmBackendModuleThreadedSimd = "+Tn.toString()],{type:"text/javascript"}):u=On(i);u.tfjs={init:u.cwrap("init",null,[]),registerTensor:u.cwrap("register_tensor",null,["number","number","number"]),disposeData:u.cwrap("dispose_data",null,["number"]),dispose:u.cwrap("dispose",null,[])};var s=!1;u.onRuntimeInitialized=function(){s=!0,Hn=!1,e({wasm:u})},u.onAbort=function(){if(!s&&!Hn){Hn=!0;a({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})}}}))]}}))}))}var Pn=["tfjs-backend-wasm.wasm","tfjs-backend-wasm-simd.wasm","tfjs-backend-wasm-threaded-simd.wasm"],Wn=null,Bn=null,Ln={},Hn=!1,Un=!1;n.registerBackend("wasm",(function(){return Mn(void 0,void 0,void 0,(function(){var e;return xn(this,(function(n){switch(n.label){case 0:return[4,Dn()];case 1:return e=n.sent().wasm,[2,new Cn(e)]}}))}))}),2),e.BackendWasm=Cn,e.setWasmPath=function(e,t){if(void 0===t&&(t=!1),n.deprecationWarn("setWasmPath has been deprecated in favor of setWasmPaths and will be removed in a future release."),Hn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");Wn=e,Un=t},e.setWasmPaths=function(e,n){if(void 0===n&&(n=!1),Hn)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPaths()` before you call `tf.setBackend()` or `tf.ready()`");if("string"==typeof e)Bn=e;else{Ln=e;var t=Pn.filter((function(e){return null==Ln[e]}));if(t.length>0)throw new Error("There were no entries found for the following binaries: "+t.join(",")+". Please either call setWasmPaths with a map providing a path for each binary, or with a string indicating the directory where all the binaries can be found.")}Un=n},e.version_wasm="2.8.5",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.min.js.map
